
!===========================================================================================
!MAIN CODE.   ( LOGNORMAL  )
!
!Last modified: March 24 2013
!===========================================================================================        

PROGRAM OLG          	
    	
 !  INCLUDE 'link_fnl_static.h'
	USE PARAME	
	USE UTILITIES
 !	USE LSARG_INT
 !	USE WRRRN_INT
            IMPLICIT NONE
	
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxx   DEFINE VARIABLES   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	 
	Real*8  :: k(kgrid), kk(kgrid), kn(kgrid+1), z(zgrid), tz(zgrid,zgrid)
	Real*8  :: b(bgrid), bb(bgrid), bbk(bgrid)  
	Real*8  :: payH(3), payL(3), dddL(3), ssseqL(3), dddH(3), ssseqH(3), TV2L(3), TV2H(3)  
	Real*8  :: stdisC(egrid*(sgrid-1)), stat1C(egrid*(sgrid-1))	
    Real*8  :: s(sgrid), e(egrid), te(egrid,egrid), ss(sgrid)
    Real*8  :: stdise(egrid), stdise2(egrid),bprime,bnow     
    Real*8  :: optShare(sgrid,egrid), optShare2(sgrid,egrid), wealth(sgrid,egrid), optCons(sgrid,egrid), VC(sgrid,egrid), VC2(sgrid,egrid) 
    Real*8  :: wwwp(egrid), sssp(egrid), cccp(egrid), mu1p(egrid)            	
    Integer :: x1, x2, x3, x4, xoL, xoH, xx(1), onesK(kgrid)=1, onesB(bgrid)=1, Regime(zgrid*(kgrid-1)*bgrid), Regime2(zgrid*(kgrid-1)*bgrid), onesC(sgrid)=1, sorun(2)   
    Real*8  :: optL(kgrid,zgrid,bgrid), optY(kgrid,zgrid,bgrid), optS(kgrid,zgrid,bgrid), optD(kgrid,zgrid,bgrid), optG(kgrid,zgrid,bgrid), optI(kgrid,zgrid,bgrid), optAC(kgrid,zgrid,bgrid), optAC2(kgrid,zgrid,bgrid), optBAC(kgrid,zgrid,bgrid)
    Real*8  :: optIK(kgrid,zgrid,bgrid), optIK2(kgrid,zgrid,bgrid), optEK(kgrid,zgrid,bgrid), optEK2(kgrid,zgrid,bgrid)
    Real*8  :: V(kgrid,zgrid,bgrid), V2(kgrid,zgrid,bgrid), PV(kgrid,zgrid,bgrid), ncf(kgrid,bgrid)    
    	
	Real*8, Dimension(:,:,:), Allocatable  :: optK, optK2, optB, optB2, optMULT, optMULT2, qqq, pi	
	Real*8, Dimension(:,:), Allocatable  ::  transC    
	Real*8, Dimension(:), Allocatable  ::  stdis, stat1, trans	        
               	
        Allocate( optK(kgrid,zgrid,bgrid) )
        Allocate( optK2(kgrid,zgrid,bgrid) )
        Allocate( optB(kgrid,zgrid,bgrid) )
        Allocate( optB2(kgrid,zgrid,bgrid) )        
        Allocate( optMULT(kgrid,zgrid,bgrid) )
        Allocate( optMULT2(kgrid,zgrid,bgrid) )  
        Allocate( qqq(kgrid,zgrid,bgrid) )                                	                                                                               			 
        Allocate( pi(kgrid,zgrid,bgrid) )	
          
        Allocate( transC( (sgrid-1)*egrid , (sgrid-1)*egrid ) )	

        Allocate( stdis(zgrid*(kgrid-1)*(bgrid)) )
        Allocate( stat1(zgrid*(kgrid-1)*(bgrid)) )
        Allocate( trans(zgrid*(kgrid-1)*(bgrid)) )                           
                
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxx   ALLOCATE VARIABLES   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 
            ti = 0.28_8
            
            ss(1)     = share_min 
            ss(sgrid) = share_max
            print *, sqrt(ss(sgrid))
	    do i=2,sgrid
			ss(i)     = sqrt(ss(1)) + ( (i-1)*(sqrt(ss(sgrid))-sqrt(ss(1)))/(sgrid-1) ) 	
        end do 
        do i=1,sgrid
			s(i)      = ss(i)**2						
        end do 

        print *, "==========================="        
        print *, "s - 1   = ", s(1)
        print *, "s - 4   = ", s(4)
        print *, "s - 16  = ", s(16)
        print *, "s - 67  = ", s(67)
        print *, "s - 68  = ", s(68)
        print *, "s - 69  = ", s(69)                               
        print *, "s - 70  = ", s(70) 
        print *, "s - 170 = ", s(170) 
        print *, "s - 270 = ", s(270) 
        print *, "s - 300 = ", s(300) 
        print *, "==========================="  
                                        
			e(1)  = (0.167_8) * 1.00_8  ! 0.167_8  ! 1.00_8
			e(2)  = (0.167_8) * 5.29_8  ! 0.839_8  ! 5.29_8
			e(3)  = (0.167_8) * 46.55_8 ! 5.087_8  ! 46.55_8
			
			te(1,1)  = 0.992_8
            te(1,2)  = 0.008_8
		    te(1,3)  = 0.000_8

			te(2,1)  = 0.009_8
            te(2,2)  = 0.980_8
		    te(2,3)  = 0.011_8           

			te(3,1)  = 0.000_8
            te(3,2)  = 0.083_8
		    te(3,3)  = 0.917_8
		    		   		   
	     stdise = 1.0_8
	     stdise = stdise / ( egrid )
	   
	     prdiff = 1.0_8
	 	 DO 
			if (prdiff.lt.toldist) exit
			stdise2 = MATMUL(stdise,te)			
			prdiff  = MAXVAL(abs(stdise2-stdise))			
			stdise=stdise2
	  	 END DO                                 		             

         print *, "--------------------------------------"             
         print *, stdise(1), stdise(2), stdise(3)   
         print *, "--------------------------------------"            
         lss  = ( stdise(1)*e(1) ) + ( stdise(2)*e(2) ) + ( stdise(3)*e(3) )   
         print *, "lss old  = ", lss          
         e(1) = LLL*e(1)/lss 
         e(2) = LLL*e(2)/lss 
         e(3) = LLL*e(3)/lss   
         lss  = ( stdise(1)*e(1) ) + ( stdise(2)*e(2) ) + ( stdise(3)*e(3) )                           

         print *, "--------------------------------------"             
         print *, "lss  = ", lss
         print *, "e(1) = ", e(1)
         print *, "e(2) = ", e(2)
         print *, "e(3) = ", e(3)     
         print *, "--------------------------------------"    
            
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx            

            
            bbk(1)      = bk_min 
	        do i=2,bgrid
			    bbk(i)  = bbk(i-1) + 0.0050_8
			end do

         OPEN (UNIT=1191919, FILE="bbbbb.txt", STATUS="NEW")        
      
         do i=1,bgrid     
	        WRITE(1191919,*) bbk(i)	        	  	        	        	              			        
	     end do  

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx            
            
            kk(1)     = k_min 
            kk(kgrid) = k_max
	        do i=2,kgrid
			    kk(i)     = (kk(1)**curve) + ( (i-1)*((kk(kgrid)**curve)-(kk(1)**curve))/(kgrid-1) ) 	
            end do 
            do i=1,kgrid
			    k(i)      = ( kk(i)**(1.0_8/curve) )						
            end do 
            
                k(1) = k(2) / 2.0_8

         OPEN (UNIT=119191, FILE="kkkkk.txt", STATUS="NEW")        
      
         do i=1,kgrid     
	        WRITE(119191,*) k(i)	        	  	        	        	              			        
	     end do     	

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx            
	         	 
	     GS = ((5**(0.5_8))-1.0_8)/2
	     print *, "Golden Search Parameter = ", GS    	     	     	     	     	     	     	     	
          
        print *, "--------------------------------------"             
        print *, "k - 1   = ", k(1)
        print *, "k - 2   = ", k(2)        
        print *, "k - 199 = ", k(199)
        print *, "k - 200 = ", k(200)
        print *, "k - 201 = ", k(201)  
        print *, "k - 202 = ", k(202)                
        print *, "k - 299 = ", k(299)
        print *, "k - 300 = ", k(300)
        print *, "k - 301 = ", k(301)
        print *, "k - 399 = ", k(399)        
        print *, "k - 400 = ", k(400)                                                          
        print *, "--------------------------------------"                       
        print *, "b - 1   = ", bbk(1)
        print *, "b - 2   = ", bbk(2)  
        print *, "b - 3   = ", bbk(3)   
        print *, "b - 4   = ", bbk(4)  
        print *, "b - 5   = ", bbk(5)                                                                            
        print *, "b - max = ", bbk(bgrid)                                                          
        print *, "--------------------------------------"       
                  
			z(1)  = 0.3586721077352130_8
			z(2)  = 0.4696513091569100_8
			z(3)  = 0.5920330886999700_8
			z(4)  = 0.7339431549664090_8
			z(5)  = 0.9027393336554150_8
			z(6)  = 1.1077394799568000_8
			z(7)  = 1.3625033399838300_8
			z(8)  = 1.6890947804891700_8
			z(9)  = 2.1292392472942100_8
			z(10) = 2.7880617935817900_8
			
			tz(1,1)  = 0.30815400473981700000_8
            tz(1,2)  = 0.46324670264632000000_8
		    tz(1,3)  = 0.19537690616878300000_8
            tz(1,4)  = 0.03112261061973130000_8
            tz(1,5)  = 0.00204418744296803000_8
            tz(1,6)  = 0.00005502805600693310_8
            tz(1,7)  = 0.00000055855473248835_8
            tz(1,8)  = 0.00000000177046611372_8
            tz(1,9)  = 0.00000000000117482991_8
            tz(1,10) = 1.0_8-tz(1,1)-tz(1,2)-tz(1,3)-tz(1,4)-tz(1,5)-tz(1,6)-tz(1,7)-tz(1,8)-tz(1,9)

			tz(2,1)  = 0.06217460284230930000_8
            tz(2,2)  = 0.32689158001146200000_8
		    tz(2,3)  = 0.40415217795807000000_8
            tz(2,4)  = 0.17463777751912100000_8
            tz(2,5)  = 0.02999895144847120000_8
            tz(2,6)  = 0.00208897775100448000_8
            tz(2,7)  = 0.00005545472577719280_8
            tz(2,8)  = 0.00000047681611660071_8
            tz(2,9)  = 0.00000000092750999471_8
            tz(2,10) = 1.0_8-tz(2,1)-tz(2,2)-tz(2,3)-tz(2,4)-tz(2,5)-tz(2,6)-tz(2,7)-tz(2,8)-tz(2,9)

			tz(3,1)  = 0.00737068273969328000_8
            tz(3,2)  = 0.11360010435705300000_8
		    tz(3,3)  = 0.35378864171176500000_8
            tz(3,4)  = 0.36026446601983000000_8
            tz(3,5)  = 0.14133297498425900000_8
            tz(3,6)  = 0.02226575981046680000_8
            tz(3,7)  = 0.00134988403310257000_8
            tz(3,8)  = 0.00002735225237348440_8
            tz(3,9)  = 0.00000013402466585392_8
            tz(3,10) = 1.0_8-tz(3,1)-tz(3,2)-tz(3,3)-tz(3,4)-tz(3,5)-tz(3,6)-tz(3,7)-tz(3,8)-tz(3,9)

			tz(4,1)  = 0.00054076379106186700_8
            tz(4,2)  = 0.02260836195686510000_8
		    tz(4,3)  = 0.16592755868573500000_8
            tz(4,4)  = 0.37430705948536200000_8
            tz(4,5)  = 0.31596216614576700000_8
            tz(4,6)  = 0.10617469837734600000_8
            tz(4,7)  = 0.01385048459841770000_8
            tz(4,8)  = 0.00062171816331514200_8
            tz(4,9)  = 0.00000717909109014033_8
            tz(4,10) = 1.0_8-tz(4,1)-tz(4,2)-tz(4,3)-tz(4,4)-tz(4,5)-tz(4,6)-tz(4,7)-tz(4,8)-tz(4,9)

			tz(5,1)  = 0.00002451717177954580_8
            tz(5,2)  = 0.00268074216804944000_8
		    tz(5,3)  = 0.04493230152833390000_8
            tz(5,4)  = 0.21809873746772300000_8
            tz(5,5)  = 0.38517782734297500000_8
            tz(5,6)  = 0.26853080207120900000_8
            tz(5,7)  = 0.07328905213427480000_8
            tz(5,8)  = 0.00707868658161891000_8
            tz(5,9)  = 0.00018667354940234700_8
            tz(5,10) = 1.0_8-tz(5,1)-tz(5,2)-tz(5,3)-tz(5,4)-tz(5,5)-tz(5,6)-tz(5,7)-tz(5,8)-tz(5,9)

            tz(6,1)  = tz(5,10)
            tz(6,2)  = tz(5,9)
            tz(6,3)  = tz(5,8)
            tz(6,4)  = tz(5,7)
            tz(6,5)  = tz(5,6)
            tz(6,6)  = tz(5,5)
            tz(6,7)  = tz(5,4)
            tz(6,8)  = tz(5,3)
            tz(6,9)  = tz(5,2)
            tz(6,10) = tz(5,1)
            
            tz(7,1)  = tz(4,10)
            tz(7,2)  = tz(4,9)
            tz(7,3)  = tz(4,8)
            tz(7,4)  = tz(4,7)
            tz(7,5)  = tz(4,6)
            tz(7,6)  = tz(4,5)
            tz(7,7)  = tz(4,4)
            tz(7,8)  = tz(4,3)
            tz(7,9)  = tz(4,2)
            tz(7,10) = tz(4,1)
            
            tz(8,1)  = tz(3,10)
            tz(8,2)  = tz(3,9)
            tz(8,3)  = tz(3,8)
            tz(8,4)  = tz(3,7)
            tz(8,5)  = tz(3,6)
            tz(8,6)  = tz(3,5)
            tz(8,7)  = tz(3,4)
            tz(8,8)  = tz(3,3)
            tz(8,9)  = tz(3,2)
            tz(8,10) = tz(3,1)
            
            tz(9,1)  = tz(2,10)
            tz(9,2)  = tz(2,9)
            tz(9,3)  = tz(2,8)
            tz(9,4)  = tz(2,7)
            tz(9,5)  = tz(2,6)
            tz(9,6)  = tz(2,5)
            tz(9,7)  = tz(2,4)
            tz(9,8)  = tz(2,3)
            tz(9,9)  = tz(2,2)
            tz(9,10) = tz(2,1)
            
            tz(10,1)  = tz(1,10)
            tz(10,2)  = tz(1,9)
            tz(10,3)  = tz(1,8)
            tz(10,4)  = tz(1,7)
            tz(10,5)  = tz(1,6)
            tz(10,6)  = tz(1,5)
            tz(10,7)  = tz(1,4)
            tz(10,8)  = tz(1,3)
            tz(10,9)  = tz(1,2)
            tz(10,10) = tz(1,1)                      
    
      OPEN (UNIT=101, FILE="WAGES.txt", STATUS="NEW") 
      OPEN (UNIT=102, FILE="LABOR.txt", STATUS="NEW")
                                  
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx        
 
 CALL TIC !td
 
 td_high = 0.416788818359375_8
 td_low  = 0.416788574218750_8
 tol_td  = 1.000_8
 iterD =0
 
 DO WHILE (tol_td.gt.tol_par_td)  
     
     iterD = iterD +1
     
 td  = ( td_high + td_low ) / 2
 
 tg = tgi
 
 print *, "=============================================" 
 print *, "IterD, TAU_D                        : ", iterD, td     
 print *, "============================================="

         rhigh  =  0.05498_8  ! 0.055625_8     
         rlow   =  0.05485_8  ! 0.055625_8  

         wu     =  1.5595_8    
         wd     =  1.5585_8       

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx           	
         
         !!$omp parallel do collapse(2)
        
         do j=1,egrid
         do i=1,sgrid    
      	    optShare(i,j) = s(i) 
      	    VC(i,j)       = 1.0_8         	
 	     end do
         end do  
	     
         !!$omp parallel do collapse(3)
         do j=1,zgrid   
         do i=1,kgrid  
         do ib=1,bgrid              	 	        	        	              			        
	         optK(i,j,ib)    = k(i)
	         optB(i,j,ib)    = bbk(ib) 
	         optMULT(i,j,ib) = ( ((1.0_8-td)/(1.0_8-tg)) + 1.0_8 ) / 2.0_8
             optD(i,j,ib)    = 0
             optS(i,j,ib)    = 0 	                          
	     end do     	     	     	     	     	     	     	     	     	
         end do  
         end do        
         
         tol_r = 1.00_8
         iterR=0
         

DO WHILE (tol_r.gt.tol_par_r)	
    iterR=iterR+1
    r  = ( rhigh + rlow ) / 2
    print *, "--------------------------------------------"     
    print *, "iterR,interest    = ", iterR,r  

    tol_w  = 1.0_8
    w_down = wd
    w_up   = wu
    
         !!$omp parallel do collapse(3)
         do j=1,zgrid   
         do i=1,kgrid   
         do ib=1,bgrid            	 	        	        	              			        
             V(i,j,ib)       = -1!! maybe not needed    
             V2(i,j,ib)      = -1!! maybe avoid loop	                      
	     end do     	     	     	     	     	     	     	     	     	
         end do  
         end do     
       			     	         	
	iter = 0	

DO WHILE (tol_w.gt.tol_par_w)
    iter=iter +1
    w  = ( w_down + w_up ) / 2
 
    rf = ( 1.0_8 + ((r*(1.0_8-tb))/(1.0_8-tg)) )  ! New New New New New New New New New New New
    
    !!$omp parallel do collapse(2)
    do j=1,zgrid
    do i=1,kgrid    
    do ib=1,bgrid 
      	    pi(i,j,ib)  = z(j)*(1-nu)*(k(i)**alf)*((z(j)*nu*(k(i)**alf)/w)**(nu/(1.0_8-nu)))             	
	end do
	end do     	         	                                                	
	end do	
		
    toleranceA = 1.00000_8
    tolerrorK  = 0.00001_8  
    tolerrorK2 = 0.00000001_8 
    tolerrorK3 = 0.00001_8    
    
    iterK = 0
    
DO WHILE (toleranceA.gt.tol_POL.and.iterK.lt.1000) 
      iterK =  iterK + 1  
      
      print *, "iterK", iterK     
     
      !! V2 defined twice
      V2    =  V !! maybe delete
      V     = -10000000.0_8

    !$omp parallel do private(bprime,bnow,kfc_L,kfc_H,dc,Ifc,ncf,ddd,ssseq,TV,TV2,check,kc,bc,xx,x1,x2,x3,kL,kH,errorK,iterA1,kcL,kcH,dGS,payL1,oo,weight,payL,dddL,ssseqL,TV2L, TV2L1,xoL,payH1,dddH,ssseqH,TV2H, TV2H1,xoH,iterA2,oi,ob,nn,oj) collapse(3)
      
   
      do j=1,zgrid   
         do i=1,kgrid
            do ib=1,bgrid
         
            kfc_L = ( aL + 1 - delta ) * k(i)
            kfc_H = ( bH + 1 - delta ) * k(i)             
            bnow = bbk(ib) * k(i)
            dc = min( bcost * r * ( bnow / k(i) ) , 100.0_8 )	           		                          	                    				 
					    					                              
                        do oi=1,kgrid
                            
                             Ifc = 0.0_8                                                     
                             if (k(oi).ge.kfc_H) then
                                 Ifc = 1.0_8
                             else       
                                 if (k(oi).le.kfc_L) then
                                     Ifc = 1.0_8
                                 else
                                     check = 1
                                 end if
                             end if                         
                        
                        do ob=1,bgrid 
                             bprime = bbk(ob) * k(oi)  
                             ncf(oi,ob)  = ( (1.0_8-tc)*pi(i,j,ib) ) + ( tc*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (k(oi)) - ((1.0_8-(tc*phi))*(psi/2.0_8)*(((k(oi)/k(i))-1.0_8)**2)*k(i)) - (Ifc*(1.0_8-tc)*w*fc) + bprime - ((1+r+dc)*bnow) + (tc*(r+dc)*bnow)
				             
				             if (ncf(oi,ob).gt.0) then
				                ddd   = ncf(oi,ob)
				                ssseq = 0
				             else
				                ddd   = 0
				                ssseq = - ncf(oi,ob)				               
				             end if
				             
				             TV = 0.0_8
				             do oj=1,zgrid
                                TV = TV + (  tz(j,oj) * V2(oi,oj,ob) )                               
                             end do
                             
                             TV2 = ( ((1.0_8-td)/(1.0_8-tg))*ddd ) - ssseq + ( (1.0_8/rf)*TV )
                             
                             if (TV2.ge.V(i,j,ib)) then
                                V(i,j,ib)   = TV2
                                optK(i,j,ib)= k(oi)
                                optB(i,j,ib)= bbk(ob) 
                                optD(i,j,ib)= ddd
                                optS(i,j,ib)= ssseq                       
                             else
                                check = 1
                             end if                                                       
				             
					    end do
                        end do
					    
                        ! two continuous loops in one
                        if (conti2.eq.1) then
                        !!! in the loop we can define x1=oi and x2=ob and this is not necessary
                        !!! we need to do the adjustment for first and last points in grid
                        
                        kc = optK(i,j,ib)                    
                        xx=minloc( abs(k-(kc*onesK)) )			       
					    x1=xx(1)
					    
                        bc = optB(i,j,ib)                    
                        xx=minloc( abs(bbk-(bc*onesB)) )			       
					    x2=xx(1)
					    if(x2.eq.bgrid) x2=x2-1 	
					    					    				   					   
					    if (x2.gt.1) then
					        x3 = x2-1
					    else
					        x3 = 1 
					    end if
 					   
					   ! xxxxxx Check Off the Grid xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
                       if(x1.eq.kgrid) then
                        kL = k(x1-1)
	                    kH = k(x1)
                       elseif (x1.eq.k(1)) then
                        kL = k(x1)
	                    kH = k(x1+1)	        
                       else  
	                    kL = k(x1-1)
	                    kH = k(x1+1)	        
                       end if
                       
	                    errorK = 1.0_8		
	                    
	                    iterA1 = 1
	                    
	                    A3_LOOP : DO
	                     
	                        if (abs(errorK).lt.tolerrorK2) exit A3_LOOP	       
	                            
	                            dGS  = GS*(kH-kL)
	                            kcL  = kH - dGS
	                            kcH  = kL + dGS 
	                            
				                !-----------------------------------------------------------------------------------------------------------------------

	                            Ifc = 0.0_8                                                     
                                if (kcL.ge.kfc_H) then
                                    Ifc = 1.0_8
                                else       
                                    if (kcL.le.kfc_L) then
                                        Ifc = 1.0_8
                                    else
                                        check = 1
                                    end if
                                end if    
	                            
	                            payL1 = ( (1.0_8-tc)*pi(i,j,ib) ) + ( tc*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (kcL) - ((1.0_8-(tc*phi))*(psi/2.0_8)*(((kcL/k(i))-1.0_8)**2)*k(i)) - (Ifc*(1.0_8-tc)*w*fc)  ! New New New New New New New New New New New
				                weight = ( kcL-k(x1) ) / ( k(x1+1)-k(x1) )
				                
				                do nn=1,3
                                    oo = x3+nn-1
                                    bprime = bbk(oo) * kcL
				                    payL(nn) = payL1 + bprime - ((1+r+dc)*bnow) + (tc*(r+dc)*bnow) 	
				                				                
				                    if (payL(nn).gt.0) then
				                        dddL(nn)   = payL(nn)
				                        ssseqL(nn) = 0
				                    else
				                        dddL(nn)   = 0
				                        ssseqL(nn) = - payL(nn)				               
				                    end if      	
					            
					                TV = 0.0_8				             
				                    do oj=1,zgrid 
                                       TV = TV + (  tz(j,oj) * ((weight*V2(x1+1,oj,oo))+((1.0_8-weight)*V2(x1,oj,oo)))  )                             
                                    end do	
                                
                                    TV2L(nn) = ( ((1.0_8-td)/(1.0_8-tg))*dddL(nn) ) - ssseqL(nn) + ( (1.0_8/rf)*TV )	

                                end do

                                    TV2L1 = -10000000
                                  
                                    do nn=1,3
                                       if (TV2L(nn).gt.TV2L1) then
                                           xoL = nn          
                                           TV2L1 = TV2L(nn)                              
                                       else
                                           check = 1 
                                       end if                                     
                                    end do
                                
				                !-----------------------------------------------------------------------------------------------------------------------

	                            Ifc = 0.0_8                                                     
                                if (kcH.ge.kfc_H) then
                                    Ifc = 1.0_8
                                else       
                                    if (kcH.le.kfc_L) then
                                        Ifc = 1.0_8
                                    else
                                        check = 1
                                    end if
                                end if   				                
				                
                               
				                payH1 = ( (1.0_8-tc)*pi(i,j,ib) ) + ( tc*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (kcH) - ((1.0_8-(tc*phi))*(psi/2.0_8)*(((kcH/k(i))-1.0_8)**2)*k(i)) - (Ifc*(1.0_8-tc)*w*fc)  ! New New New New New New New New New New New
				            	weight = ( kcH-k(x1) ) / ( k(x1+1)-k(x1) )					

				                do nn=1,3
				                	oo = x3+nn-1
				                	bprime = bbk(oo) * kcH
				                    payH(nn) = payH1 + bprime - ((1+r+dc)*bnow) + (tc*(r+dc)*bnow) 
				            				                
				                    if (payH(nn).gt.0) then
				                        dddH(nn)   = payH(nn)
				                        ssseqH(nn) = 0
				                    else
				                        dddH(nn)   = 0
				                        ssseqH(nn) = - payH(nn)				               
				                    end if
					            					            
					                TV = 0.0_8				             
				                    do oj=1,zgrid 
                                       TV = TV + (  tz(j,oj) * ((weight*V2(x1+1,oj,oo))+((1.0_8-weight)*V2(x1,oj,oo)))  )                             
                                    end do	
                                
                                    TV2H(nn) = ( ((1.0_8-td)/(1.0_8-tg))*dddH(nn) ) - ssseqH(nn) + ( (1.0_8/rf)*TV )				            

                                end do
                                
                                    TV2H1 = -10000000
                                  
                                    do nn=1,3
                                       if (TV2H(nn).gt.TV2H1) then
                                           xoH = nn        
                                           TV2H1 = TV2H(nn)                                
                                       else
                                           check = 1 
                                       end if                                    
                                    end do

				                !-----------------------------------------------------------------------------------------------------------------------

                                if (TV2H(xoH).gt.TV2L(xoL)) then
                                    kL = kcL
                                else
                                    kH = kcH
                                end if

   				                errorK = abs(kL-kH)   
   				                
   				                iterA1 = iterA1 + 1
   				                 	              
	                    END DO A3_LOOP
	                    
	                            if (TV2H(xoH).gt.TV2L(xoL)) then                                    
                                   if (TV2H(xoH).ge.V(i,j,ib)) then
                                       V(i,j,ib) = TV2H(xoH)
                                       optK(i,j,ib)= kcH
                                       optB(i,j,ib)= bbk(x3+xoH-1) 
                                       optD(i,j,ib)= dddH(xoH)
                                       optS(i,j,ib)= ssseqH(xoH)                       
                                   else
                                    check = 1
                                   end if                                      
                                else
                                   if (TV2L(xoL).ge.V(i,j,ib)) then
                                       V(i,j,ib) = TV2L(xoL)
                                       optK(i,j,ib)= kcL 
                                       optB(i,j,ib)= bbk(x3+xoL-1) 
                                       optD(i,j,ib)= dddL(xoL)
                                       optS(i,j,ib)= ssseqL(xoL)                       
                                   else
                                    check = 1
                                   end if                                        
                                end if
	                
	        	       end if ! end of the conti2 if           
                        
                        if (conti.eq.1) then
                        !!! in the loop we can define x1=oi and x2=ob and this is not necessary
                        !!! we need to do the adjustment for first and last points in grid
                        
                        kc = optK(i,j,ib)                    
                        xx=minloc( abs(k-(kc*onesK)) )			       
					    x1=xx(1)
					    if(k(x1).gt.kc.or.x1.eq.kgrid) x1=x1-1 					   

                        bc = optB(i,j,ib)                    
                        xx=minloc( abs(bbk-(bc*onesB)) )			       
					    x2=xx(1)
					    if(bbk(x2).gt.bc.or.x2.eq.bgrid) x2=x2-1 	
					    					    				   					   
					    if (x2.gt.1) then
					        x3 = x2-1
					    else
					        x3 = 1 
					    end if
 					   
					   ! xxxxxx Check Off the Grid - HIGH Interval xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

	                    kL = k(x1)
	                    kH = k(x1+1)	        
	                    errorK = 1.0_8		
	                    
	                    iterA1 = 1
	                    
	                    A1_LOOP : DO
	                     
	                        if (abs(errorK).lt.tolerrorK2) exit A1_LOOP	       
	                            
	                            dGS  = GS*(kH-kL)
	                            kcL  = kH - dGS
	                            kcH  = kL + dGS 
	                            
				                !-----------------------------------------------------------------------------------------------------------------------

	                            Ifc = 0.0_8                                                     
                                if (kcL.ge.kfc_H) then
                                    Ifc = 1.0_8
                                else       
                                    if (kcL.le.kfc_L) then
                                        Ifc = 1.0_8
                                    else
                                        check = 1
                                    end if
                                end if    
                             
	                            payL1 = ( (1.0_8-tc)*pi(i,j,ib) ) + ( tc*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (kcL) - ((1.0_8-(tc*phi))*(psi/2.0_8)*(((kcL/k(i))-1.0_8)**2)*k(i)) - (Ifc*(1.0_8-tc)*w*fc)  ! New New New New New New New New New New New
				                weight = ( kcL-k(x1) ) / ( k(x1+1)-k(x1) )
				                
				                do nn=1,3
                                    oo = x3+nn-1
                                    bprime = bbk(oo) * kcL
				                    payL(nn) = payL1 + bprime - ((1+r+dc)*bnow) + (tc*(r+dc)*bnow) 	
				                				                
				                    if (payL(nn).gt.0) then
				                        dddL(nn)   = payL(nn)
				                        ssseqL(nn) = 0
				                    else
				                        dddL(nn)   = 0
				                        ssseqL(nn) = - payL(nn)				               
				                    end if      	
					            
					                TV = 0.0_8				             
				                    do oj=1,zgrid 
                                       TV = TV + (  tz(j,oj) * ((weight*V2(x1+1,oj,oo))+((1.0_8-weight)*V2(x1,oj,oo)))  )                             
                                    end do	
                                
                                    TV2L(nn) = ( ((1.0_8-td)/(1.0_8-tg))*dddL(nn) ) - ssseqL(nn) + ( (1.0_8/rf)*TV )	

                                end do

                                    TV2L1 = -10000000
                                  
                                    do nn=1,3
                                       if (TV2L(nn).gt.TV2L1) then
                                           xoL = nn          
                                           TV2L1 = TV2L(nn)                              
                                       else
                                           check = 1 
                                       end if                                     
                                    end do
                                
				                !-----------------------------------------------------------------------------------------------------------------------

	                            Ifc = 0.0_8                                                     
                                if (kcH.ge.kfc_H) then
                                    Ifc = 1.0_8
                                else       
                                    if (kcH.le.kfc_L) then
                                        Ifc = 1.0_8
                                    else
                                        check = 1
                                    end if
                                end if   				                
				                
                               
				                payH1 = ( (1.0_8-tc)*pi(i,j,ib) ) + ( tc*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (kcH) - ((1.0_8-(tc*phi))*(psi/2.0_8)*(((kcH/k(i))-1.0_8)**2)*k(i)) - (Ifc*(1.0_8-tc)*w*fc)  ! New New New New New New New New New New New
				            	weight = ( kcH-k(x1) ) / ( k(x1+1)-k(x1) )					

				                do nn=1,3
				                	oo = x3+nn-1
				                    bprime = bbk(oo) * kcH
				                    payH(nn) = payH1 + bprime - ((1+r+dc)*bnow) + (tc*(r+dc)*bnow) 
				            				                
				                    if (payH(nn).gt.0) then
				                        dddH(nn)   = payH(nn)
				                        ssseqH(nn) = 0
				                    else
				                        dddH(nn)   = 0
				                        ssseqH(nn) = - payH(nn)				               
				                    end if
					            					            
					                TV = 0.0_8				             
				                    do oj=1,zgrid 
                                       TV = TV + (  tz(j,oj) * ((weight*V2(x1+1,oj,oo))+((1.0_8-weight)*V2(x1,oj,oo)))  )                             
                                    end do	
                                
                                    TV2H(nn) = ( ((1.0_8-td)/(1.0_8-tg))*dddH(nn) ) - ssseqH(nn) + ( (1.0_8/rf)*TV )				            

                                end do
                                
                                    TV2H1 = -10000000
                                  
                                    do nn=1,3
                                       if (TV2H(nn).gt.TV2H1) then
                                           xoH   = nn        
                                           TV2H1 = TV2H(nn)                                
                                       else
                                           check = 1 
                                       end if                                    
                                    end do

				                !-----------------------------------------------------------------------------------------------------------------------

                                if (TV2H(xoH).gt.TV2L(xoL)) then
                                    kL = kcL
                                else
                                    kH = kcH
                                end if

   				                errorK = abs(kL-kH)   
   				                
   				                iterA1 = iterA1 + 1
   				                 	              
	                    END DO A1_LOOP
	                    
	                            if (TV2H(xoH).gt.TV2L(xoL)) then                                    
                                   if (TV2H(xoH).ge.V(i,j,ib)) then
                                       V(i,j,ib) = TV2H(xoH)
                                       optK(i,j,ib)= kcH
                                       optB(i,j,ib)= bbk(x3+xoH-1) 
                                       optD(i,j,ib)= dddH(xoH)
                                       optS(i,j,ib)= ssseqH(xoH)                       
                                   else
                                    check = 1
                                   end if                                      
                                else
                                   if (TV2L(xoL).ge.V(i,j,ib)) then
                                       V(i,j,ib) = TV2L(xoL)
                                       optK(i,j,ib)= kcL 
                                       optB(i,j,ib)= bbk(x3+xoL-1) 
                                       optD(i,j,ib)= dddL(xoL)
                                       optS(i,j,ib)= ssseqL(xoL)                       
                                   else
                                    check = 1
                                   end if                                        
                                end if
	                    	
					   ! xxxxxx Check Off the Grid - LOW Interval xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx	            	                    
                    
	                    iterA2 = 1
	                    
	                    if (x1.eq.1) then
	                        check = 1
	                    else

	                        kL = k(x1-1)
	                        kH = k(x1)	        
	                        errorK = 1.0_8		
	                    
	                        A2_LOOP : DO 
	                          if (abs(errorK).lt.tolerrorK2) exit A2_LOOP	       
	                                         
	                              dGS  = GS*(kH-kL)
	                              kcL  = kH - dGS
	                              kcH  = kL + dGS 

				                !-----------------------------------------------------------------------------------------------------------------------
	                              
	                              Ifc = 0.0_8                                                     
                                  if (kcL.ge.kfc_H) then
                                      Ifc = 1.0_8
                                  else       
                                      if (kcL.le.kfc_L) then
                                          Ifc = 1.0_8
                                      else
                                          check = 1
                                      end if
                                  end if	                              
	                            
	                              payL1 = ( (1.0_8-tc)*pi(i,j,ib) ) + ( tc*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (kcL) - ((1.0_8-(tc*phi))*(psi/2.0_8)*(((kcL/k(i))-1.0_8)**2)*k(i)) - (Ifc*(1.0_8-tc)*w*fc)  ! New New New New New New New New New New New
				        		  weight = ( kcL-k(x1-1) ) / ( k(x1)-k(x1-1) )		        				        				                 

				                  do nn=1,3				                	
				                	  oo = x3+nn-1
				                      bprime = bbk(oo) * kcL
				                      payL(nn) = payL1 + bprime - ((1+r+dc)*bnow) + (tc*(r+dc)*bnow) 	

				                      if (payL(nn).gt.0) then
				                          dddL(nn)   = payL(nn)
				                          ssseqL(nn) = 0
				                      else
				                          dddL(nn)   = 0
				                          ssseqL(nn) = - payL(nn)				               
				                      end if					              					
				
					                  TV = 0.0_8				             
				                      do oj=1,zgrid 
                                         TV = TV + (  tz(j,oj) * ((weight*V2(x1,oj,oo))+((1.0_8-weight)*V2(x1-1,oj,oo)))  )                                                                
                                      end do	
                                
                                      TV2L(nn) = ( ((1.0_8-td)/(1.0_8-tg))*dddL(nn) ) - ssseqL(nn) + ( (1.0_8/rf)*TV )				            
                                   
                                  end do 

                                      TV2L1 = -10000000
                                  
                                      do nn=1,3
                                         if (TV2L(nn).gt.TV2L1) then
                                             xoL = nn          
                                             TV2L1 = TV2L(nn)                              
                                         else
                                             check = 1 
                                         end if                                     
                                      end do
                                
				                  !-----------------------------------------------------------------------------------------------------------------------
				            				        				        
	                              Ifc = 0.0_8                                                     
                                  if (kcH.ge.kfc_H) then
                                      Ifc = 1.0_8
                                  else       
                                      if (kcH.le.kfc_L) then
                                          Ifc = 1.0_8
                                      else
                                          check = 1
                                      end if
                                  end if				        
				        
				                  payH1 = ( (1.0_8-tc)*pi(i,j,ib) ) + ( tc*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (kcH) - ((1.0_8-(tc*phi))*(psi/2.0_8)*(((kcH/k(i))-1.0_8)**2)*k(i)) - (Ifc*(1.0_8-tc)*w*fc)  ! New New New New New New New New New New New
				                  weight = ( kcH-k(x1-1) ) / ( k(x1)-k(x1-1) )				            

				                  do nn=1,3
				                	 oo = x3+nn-1
				                     bprime = bbk(oo) * kcH
				                     payH(nn) = payH1 + bprime - ((1+r+dc)*bnow) + (tc*(r+dc)*bnow) 

				                     if (payH(nn).gt.0) then
				                        dddH(nn)   = payH(nn)
				                        ssseqH(nn) = 0
				                     else
				                        dddH(nn)   = 0
				                        ssseqH(nn) = - payH(nn)				               
				                     end if

					                 TV = 0.0_8				             
				                     do oj=1,zgrid 
                                        TV = TV + (  tz(j,oj) * ((weight*V2(x1,oj,oo))+((1.0_8-weight)*V2(x1-1,oj,oo)))  )                                                                
                                     end do	
                                
                                     TV2H(nn) = ( ((1.0_8-td)/(1.0_8-tg))*dddH(nn) ) - ssseqH(nn) + ( (1.0_8/rf)*TV )				            

                                  end do

                                     TV2H1 = -10000000
                                  
                                     do nn=1,3
                                        if (TV2H(nn).gt.TV2H1) then
                                            xoH = nn        
                                            TV2H1 = TV2H(nn)                                
                                        else
                                            check = 1 
                                        end if                                    
                                     end do

				                  !-----------------------------------------------------------------------------------------------------------------------

                                  if (TV2H(xoH).gt.TV2L(xoL)) then
                                      kL = kcL
                                  else
                                      kH = kcH
                                  end if

   				                  errorK = abs(kL-kH)   
   				                  
   				                  iterA2 = iterA2 + 1
   				                 	              
	                        END DO A2_LOOP		                    
	                    	       
	                            if (TV2H(xoH).gt.TV2L(xoL)) then                                    
                                   if (TV2H(xoH).ge.V(i,j,ib)) then
                                       V(i,j,ib)   = TV2H(xoH)
                                       optK(i,j,ib)= kcH 
                                       optB(i,j,ib)= bbk(x3+xoH-1)
                                       optD(i,j,ib)= dddH(xoH)
                                       optS(i,j,ib)= ssseqH(xoH)                       
                                   else
                                    check = 1
                                   end if                                      
                                else
                                   if (TV2L(xoL).ge.V(i,j,ib)) then
                                       V(i,j,ib)   = TV2L(xoL)
                                       optK(i,j,ib)= kcL 
                                       optB(i,j,ib)= bbk(x3+xoL-1) 
                                       optD(i,j,ib)= dddL(xoL)
                                       optS(i,j,ib)= ssseqL(xoL)                       
                                   else
                                    check = 1
                                   end if                                        
                                end if
	            	                    	        	                    	                    
	                    end if	                    	                    	    				   
	        	        
	        	       ! xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	                    end if ! if for continuous solution
	        end do	        	        	  	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do 
  
      tolerance1 = maxval(abs(V-V2)) 
      tolerance2 = tolerance1 
      toleranceA = max(tolerance1,tolerance2)       
          
      V2  =   V      
      !! no toc at every iteration
      PRINT *, 'Time iterK:', toc()     
      print *, "--------------------------------------------" 
                   
END DO !! end of A loop

print *, "iterK finished. iterK, time:", iterK, toc()
print *, "--------------------------------------------" 
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxx  STATIONARY DISTRIBUTION  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
       
       stdis = 1.0_8
	   stdis = stdis / ( (kgrid-1)*zgrid*(bgrid) )
	   
	   prdiff=1.0_8

	   DO 
		 if (prdiff.lt.toldist) exit
            
               stat1 = 0
               !$omp parallel do reduction(+:stat1) private(trans,xx,x1,x2,x3) collapse(3)
               
               DO j=1,zgrid
		          DO i=1,kgrid-1
		             DO ib=1,bgrid
		             	             
		                trans = 0.0_8
		                		        
                        xx=MINLOC(ABS(k-(optK(i,j,ib)*onesK)))			       
                        x1=xx(1)
                        IF (k(x1).gt.optK(i,j,ib).or.x1.eq.kgrid) x1=x1-1		
                        xx=MINLOC(ABS(k-(optK(i+1,j,ib)*onesK)))		                
                        x2=xx(1)                
                        IF (k(x2).gt.optK(i+1,j,ib).or.x2.eq.kgrid) x2=x2-1   
                        
                        xx=MINLOC(ABS(bbk-(optB(i,j,ib)*onesB)))			       
                        x3=xx(1)	                     
                        
                                     
                        IF (x2.eq.x1) then
                               trans( ((((x1-1)*(bgrid)*zgrid)+((x3-1)*zgrid))+1) : (((x1-1)*(bgrid)*zgrid)+(x3*zgrid)) ) = tz(j,:)				        
				        ELSE
                            DO oo=x1,x2
                               trans( ((((oo-1)*(bgrid)*zgrid)+((x3-1)*zgrid))+1) : (((oo-1)*(bgrid)*zgrid)+(x3*zgrid)) ) = tz(j,:)*(min(k(oo+1),optK(i+1,j,ib))-max(k(oo),optK(i,j,ib)))/(optK(i+1,j,ib)-optK(i,j,ib))
                            END DO				         			           
                        END IF
                              
                        stat1 = stat1 + ( stdis( ((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j ) * trans )                                               
                        
                     END DO                            				
                  END DO
	           END DO			
			 prdiff=MAXVAL(abs(stat1-stdis))
			 !write(*,*) prdiff
			 stdis=stat1
	   END DO
       PRINT *, 'StatF finished. Time:', toc()     
      print *, "--------------------------------------------" 
      
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
               
   
             !$omp parallel do private(bnow,kc,kfc_L,kfc_H,bc,dc,Ifc,check,pay) collapse(3)
             do j=1,zgrid
               do i=1,kgrid                                
                  do ib=1,bgrid  
                   
                  optL(i,j,ib)   = ( z(j)*nu*(k(i)**alf)/w)**(1.0_8/(1.0_8-nu) )
                  optY(i,j,ib)   = ( z(j) * (k(i)**alf) * (optL(i,j,ib)**nu)   )  
                                    
                  kc    =  optK(i,j,ib)                  
                  kfc_L = ( aL + 1 - delta ) * k(i)
                  kfc_H = ( bH + 1 - delta ) * k(i) 
                  
                  bc = optB(i,j,ib) * kc
                  dc = bcost * r * ( bbk(ib) )      
                                    
                  Ifc = 0.0_8                                                     
                  if (kc.ge.kfc_H) then
                      Ifc = 1.0_8
                  else       
                      if (kc.le.kfc_L) then
                          Ifc = 1.0_8
                      else
                          check = 1
                      end if
                  end if	                 
                  
                  bnow = bbk(ib) * k(i)
                  pay = ( (1.0_8-tc)*pi(i,j,ib) ) + ( tc*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (kc) - ((1.0_8-(tc*phi))*(psi/2.0_8)*(((kc/k(i))-1.0_8)**2)*k(i)) - (Ifc*(1.0_8-tc)*w*fc) +  bc - ((1+r+dc)*bnow) + (tc*(r+dc)*bnow)    ! New New New New New New New New New New New   
                            
                  optAC2(i,j,ib) = Ifc*w*fc          
                  optBAC(i,j,ib) = bcost * r * ( bnow / k(i) ) * bnow
                                                                                                                              
                  if (pay.lt.0) then
	                  optS(i,j,ib) = -pay
	                  optD(i,j,ib) = 0.0_8	           
	              else
	                  optS(i,j,ib) = 0.0_8
	                  optD(i,j,ib) = pay	           
	              end if 	              
	              
	              optAC(i,j,ib)  =   (psi/2.0_8)*(((kc/k(i))-1.0_8)**2)*k(i)               
                  optG(i,j,ib)   =   ( tc*(pi(i,j,ib)-(delta*k(i))-(phi*optAC(i,j,ib))-(optAC2(i,j,ib))-((r+dc)*bnow)) ) + ( td*optD(i,j,ib) ) - ( tg*optS(i,j,ib) ) + ( tb*r*bnow )	              
	              optI(i,j,ib)   =   (kc) - ((1.0_8-delta)*k(i))  ! New New New New New New New New New New New
                  PV(i,j,ib) = V(i,j,ib) + optS(i,j,ib) - ( ((1.0_8-td)/(1.0_8-tg))*optD(i,j,ib) ) 
                  end do
               end do
            end do
     
!xxxxxxxxxxxx  CALCULATE STOCK PRICE AGGREGATES  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
               K_AGG    = 0.0_8
               KP_AGG   = 0.0_8               
               L_AGG    = 0.0_8  
               I_AGG    = 0.0_8               
               Y_AGG    = 0.0_8  
               G_AGG    = 0.0_8               
               AC_AGG   = 0.0_8 
               BAC_AGG  = 0.0_8
               AC2_AGG  = 0.0_8  
               DIV_AGG  = 0.0_8
               SEQ_AGG  = 0.0_8   
               EARN_AGG = 0.0_8
               B_AGG    = 0.0_8
               BP_AGG   = 0.0_8                
               V_AGG   = 0.0_8
               PV_AGG  = 0.0_8   	

! xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx            
! xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
! xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
    !! maybe parallelize if we define each point and sum at the end
            
            do i=1,kgrid-1
              do ib=1,bgrid
                 V_AGG    = V_AGG    + sum(  ( (V(i,:,ib) + V(i+1,:,ib))/2.0_8 )   * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
                 PV_AGG   = PV_AGG   + sum(  ( (PV(i,:,ib)+PV(i+1,:,ib))/2.0_8 )   * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )         
                 K_AGG    = K_AGG    + sum(  ( (k(i)+k(i+1))/2.0_8 )                    * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
                 KP_AGG   = KP_AGG   + sum(  ( (optK(i,:,ib)+optK(i+1,:,ib))/2.0_8 )    * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
                 L_AGG    = L_AGG    + sum(  ( (optL(i,:,ib)+optL(i+1,:,ib))/2.0_8 )    * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
                 Y_AGG    = Y_AGG    + sum(  ( (optY(i,:,ib)+optY(i+1,:,ib))/2.0_8 )    * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )  
                 G_AGG    = G_AGG    + sum(  ( (optG(i,:,ib)+optG(i+1,:,ib))/2.0_8 )    * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )             
                 I_AGG    = I_AGG    + sum(  ( (optI(i,:,ib)+optI(i+1,:,ib))/2.0_8 )    * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )                                 
                 DIV_AGG  = DIV_AGG  + sum(  ( (optD(i,:,ib)+optD(i+1,:,ib))/2.0_8 )    * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )   
                 SEQ_AGG  = SEQ_AGG  + sum(  ( (optS(i,:,ib)+optS(i+1,:,ib))/2.0_8 )    * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )   
                 AC_AGG   = AC_AGG   + sum(  ( (optAC(i,:,ib)+optAC(i+1,:,ib))/2.0_8 )  * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
                 BAC_AGG  = BAC_AGG  + sum(  ( (optBAC(i,:,ib)+optBAC(i+1,:,ib))/2.0_8 )* ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
                 AC2_AGG  = AC2_AGG  + sum(  ( (optAC2(i,:,ib)+optAC2(i+1,:,ib))/2.0_8 )* ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
                 EARN_AGG = EARN_AGG + sum(  ( (pi(i,:,ib)+pi(i+1,:,ib))/2.0_8 )        * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )                                                                          
                 B_AGG    = B_AGG    + sum(  ( ((k(i)+k(i+1))*bbk(ib))/2.0_8 )          * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
                 BP_AGG   = BP_AGG   + sum(  ( (optB(i,:,ib)+optB(i+1,:,ib))/2.0_8 )    * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
              end do
            end do 
               
               AC2_AGG = AC2_AGG  

               G_AGG    = G_AGG    +  ( tg * (PV_AGG-PV_AGG) )    ! New New New New New New New New New New New                                  

            if (check_ti.gt.0) then
                check = 1
            else
                ti = ( gov - G_AGG ) / ( w*L_AGG )
            end if 
                                   
               G_AGG  =  G_AGG + (ti*w*L_AGG)    
               C_AGG  =  Y_AGG - I_AGG - AC_AGG - BAC_AGG - AC2_AGG - G_AGG
            print *, "--------------------------------------------" 
            PRINT *, 'Agg Firm finished. Time:', toc() 
            print *, "--------------------------------------------" 
      
            Lcheck = L_AGG 
            if (Lcheck.gt.LLL) then
                w_down  = ( w_up + w_down ) / 2 
                w_up    =   w_up 
            else
                w_down  =   w_down 
                w_up    = ( w_up + w_down ) / 2        
            end if        
               
                tol_w  = abs( w_up - w_down )
                
                
                WRITE(101,*) w
                WRITE(102,*) L_AGG 
            
END DO   ! wage loop

print *, "iter w finished. iter,time:", iter, toc()
print *, "--------------------------------------------" 
      
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
     
     print *, "K_AGG  - ", K_AGG
     print *, "L_AGG  - ", L_AGG     
     print *, "PV_AGG - ", PV_AGG     
     print *, "B_AGG  - ", B_AGG     

     toleranceC = 1.0_8
     RR = 1.0_8 + (r*(1.0_8-tb))
 
 DO WHILE (toleranceC.ge.tol_par)   
     
     
      !$omp parallel do private(smin,smax,errorS, sss,ccc,mu0,xx,x1,weight,wwwp,sssp,cccp,mu1p,mu1,oo) collapse(2)
  
     do j=1,egrid
     do i=1,sgrid
        wealth(i,j) = ( ( (((1.0_8-td)*DIV_AGG)-((1.0_8-tg)*SEQ_AGG)+PV_AGG-(tg*(PV_AGG-(PV_AGG)))) + (B_AGG*(1.0_8+(r*(1.0_8-tb)))) )*s(i) ) + ( w*(1.0_8-ti)*e(j) )   ! New New New New New New New New New New New                     
        smin = s(1)
        smax = min ( (wealth(i,j)-0.000001_8)/ (PV_AGG+B_AGG) , s(sgrid) )
        errorS = 1.0_8
        
        CON_LOOP : DO 
	         if (abs(errorS).lt.tolS) exit CON_LOOP	       
             sss  = (smin+smax)/2.0_8
             ccc  = wealth(i,j) - ((PV_AGG+B_AGG)*sss)
             mu0  = (ccc**(-sigma))  
             
             xx=minloc( abs(s-(sss*onesC)) )			       
			 x1=xx(1)
			 if(s(x1).gt.sss.or.x1.eq.sgrid) x1=x1-1 
			 weight= ( sss-s(x1) ) / ( s(x1+1)-s(x1) )
			 
			 do oo=1,egrid
			    wwwp(oo) = ( ( (((1.0_8-td)*DIV_AGG)-((1.0_8-tg)*SEQ_AGG)+PV_AGG-(tg*(PV_AGG-(PV_AGG)))) + (B_AGG*(1.0_8+(r*(1.0_8-tb)))) ) *sss ) + ( w*(1.0_8-ti)*e(oo) )   ! New New New New New New New New New New New  
			    sssp(oo) = ((weight*optShare(x1+1,oo))+((1.0_8-weight)*optShare(x1,oo)))
			    sssp(oo) = min ( (wwwp(oo)-0.000001_8)/ (PV_AGG+B_AGG) , sssp(oo) )
			    cccp(oo) = wwwp(oo) - ( (PV_AGG+B_AGG)*sssp(oo) )
			    mu1p(oo) = (cccp(oo)**(-sigma))			    
			 end do
			 
				mu1 = beta*RR*sum(te(j,:)*mu1p)	
				
				if (mu0.lt.mu1) then
				    smin = sss
				else
				    smax = sss
				end if  				  
				    errorS = abs(smin-smax)			 		               	              
	    END DO CON_LOOP
        
        optShare2(i,j) = sss
        optCons(i,j)   = ccc
     !  VC2(i,j)       = ( (optCons(i,j)**(1.0_8-sigma))/(1.0_8-sigma) ) + ( beta * sum(te(j,:)*((weight*VC(x1+1,:))+((1.0_8-weight)*VC(x1,:)))) )
        VC2(i,j)       = ( log(optCons(i,j)) )                           + ( beta * sum(te(j,:)*((weight*VC(x1+1,:))+((1.0_8-weight)*VC(x1,:)))) )
     end do
     end do   
     
	 toleranceCA = MAXVAL(abs(optShare-optShare2))
	 toleranceCB = MAXVAL(abs(VC-VC2))
	 toleranceC  = max(toleranceCA,toleranceCB) 

     optShare = optShare2
     VC       = VC2				
      					    		     
 END DO
     print *, "--------------------------------------------"    
     PRINT *, 'Consumer finished. Time:', toc()
      
!xxxxxxxxxxxx   DISTRIBUTION   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

       transC = 0.0_8
       !$omp parallel do private(xx,x1,x2,oo) collapse(2)
       DO j=1,egrid
		  DO i=1,sgrid-1		        
                xx=MINLOC(ABS(s-(optShare(i,j)*onesC)))			       
                x1=xx(1)
                IF (s(x1).gt.optShare(i,j).or.x1.eq.sgrid) x1=x1-1		
                xx=MINLOC(ABS(s-(optShare(i+1,j)*onesC)))		                
                x2=xx(1)                
                IF (s(x2).gt.optShare(i+1,j).or.x2.eq.sgrid) x2=x2-1                
                IF (x2.eq.x1) then
                    transC( ((i-1)*egrid)+j , (((x1-1)*egrid)+1):(x1*egrid) ) = te(j,:)
				ELSE
                    DO oo=x1,x2
                        transC((i-1)*egrid+j,(oo-1)*egrid+1:oo*egrid)=te(j,:)*(min(s(oo+1),optShare(i+1,j))-max(s(oo),optShare(i,j)))/(optShare(i+1,j)-optShare(i,j))
                    END DO
                END IF				
          END DO
       END DO
       print *, "--------------------------------------------"    
       PRINT *, 'StatC1 finished. Time:', toc()
      
       stdisC = 1.0_8
	   stdisC = stdisC / ( (sgrid-1)*egrid )
	   
	    prdiff=1.0_8
		DO 
			if (prdiff.lt.toldist) exit
			stat1C  = MATMUL(stdisC,transC)			
			prdiff  = MAXVAL(abs(stat1C-stdisC))		
			stdisC=stat1C
		END DO
    print *, "--------------------------------------------"    
           
    PRINT *, 'StatC2 finished. Time:', toc()
    print *, "--------------------------------------------" 
      
     
!xxxxxxxxxxx   CHECK AGGREGATES   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

            S_AGG    = 0.0_8
            CONS_AGG = 0.0_8
            VC_AGG    =  0.0_8            

            do i=1,sgrid-1
               S_AGG    = S_AGG    + sum(  ( (s(i)+s(i+1))/2.0_8 )                 * ( stdisC(((i-1)*egrid)+1:(i*egrid)) )  )                                                                          
               CONS_AGG = CONS_AGG + sum(  ( (optCons(i,:)+optCons(i+1,:))/2.0_8 ) * ( stdisC(((i-1)*egrid)+1:(i*egrid)) )  )  
               VC_AGG   = VC_AGG   + sum(  ( (VC(i,:)+VC(i+1,:))/2.0_8 )           * ( stdisC(((i-1)*egrid)+1:(i*egrid)) )  )                                                                                                              
            end do                
        
        if (S_AGG.gt.totshare) then
           rhigh = r
           rlow  = rlow
           wu    = wu
           wd    = w
        else
           rhigh = rhigh
           rlow  = r  
           wu    = w
           wd    = wd      
        end if
        
            tol_r  = abs( rhigh - rlow )         
             
               print *, "td          = ", td, td_low, td_high        
               print *, "wage        = ", w, wd, wu 
               print *, "interest    = ", r, rlow, rhigh                                     
               print *, "tol_r       = ", tol_r      
               print *, "S_AGG       = ", S_AGG               
               print *, "ti          = ", ti 
               print *, "tol_w       = ", tol_w
               print *, "tol_r       = ", tol_r   
               print *, "G_AGG       = ", G_AGG                                                    
               print *, "toleranceA  = ", toleranceA
               print *, "toleranceB  = ", toleranceB
               print *, "toleranceC  = ", toleranceC   
               
               print *, "=========================================================================" 
               print *, "===============  AGGREGATES  ============================================"                      
               print *, "========================================================================="                                                             
               print *, " "
               print *, "V_AGG    = ", V_AGG 
               print *, "PV_AGG   = ", PV_AGG               
               print *, "K_AGG    = ", K_AGG 
               print *, "KP_AGG   = ", KP_AGG    
               print *, "B_AGG    = ", B_AGG 
               print *, "BP_AGG   = ", BP_AGG                                
               print *, "I_AGG    = ", I_AGG 
               print *, "L_AGG    = ", L_AGG
               print *, "Y_AGG    = ", Y_AGG
               print *, "AC_AGG   = ", AC_AGG  
               print *, "AC2_AGG  = ", AC2_AGG 
               print *, "BAC_AGG  = ", BAC_AGG                                
               print *, "C_AGG    = ", C_AGG                           
               print *, "G_AGG    = ", G_AGG  
               print *, "DIV_AGG  = ", DIV_AGG
               print *, "SEQ_AGG  = ", SEQ_AGG  
               print *, "EARN_AGG = ", EARN_AGG                                                      
               print *, " "
               print *, "========================================================================="       
                                                                                                                                         

               M_IK    = 0.0_8 
               M_IK2   = 0.0_8  
               M_EK    = 0.0_8
               M_EK2   = 0.0_8  
               VAR_IK  = 0.0_8                                                      
               VAR_EK  = 0.0_8 
    
               
               !! not needed or par
    do j=1,zgrid           
    do i=1,kgrid   
    do ib=1,bgrid          
               optIK(i,j,ib)  = ( optI(i,j,ib) / k(i) )
               optEK(i,j,ib)  = ( pi(i,j,ib)   / k(i) )
               optIK2(i,j,ib) = ( optI(i,j,ib) / k(i) ) ** 2
               optEK2(i,j,ib) = ( pi(i,j,ib)   / k(i) ) ** 2               
    end do
    end do 
    end do                                        
               
    do i=1,kgrid-1
       do ib=1,bgrid
         M_IK   = M_IK   + sum(  ( (optIK(i,:,ib)  + optIK(i+1,:,ib)) /2.0_8 ) * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
         M_IK2  = M_IK2  + sum(  ( (optIK2(i,:,ib) + optIK2(i+1,:,ib))/2.0_8 ) * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )        
         M_EK   = M_EK   + sum(  ( (optEK(i,:,ib)  + optEK(i+1,:,ib)) /2.0_8 ) * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
         M_EK2  = M_EK2  + sum(  ( (optEK2(i,:,ib) + optEK2(i+1,:,ib))/2.0_8 ) * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )                   
       end do
    end do
            
         VAR_IK  = M_IK2 - (M_IK**2)   
         VAR_EK  = M_EK2 - (M_EK**2)  

         print *, "STD_IK  = ", (VAR_IK**(0.5)) 
 
END DO !R loop
      
   
        if (G_AGG.gt.gov) then
           td_high = td
           td_low  = td_low
        else
           td_high = td_high
           td_low  = td       
        end if
           tol_td  = abs( td_high - td_low )

                print *, "--------------------------------------------"             
                

                PRINT *, 'iterR finished. iterR, time:', iterR, toc()

                print *, "tol_td = ", tol_td
                print *, "--------------------------------------------"  

 END DO  
 PRINT *, 'iterD finished. iterD, time:', iterD, toc()
 print *, "--------------------------------------------" 
 
                print *, "td          = ", td 
                print *, "tg          = ", tg 
                print *, "tc          = ", tc 
                print *, "ti          = ", ti     
                print *, "tb          = ", tb                                                              
      
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
               
               M_IK    = 0.0_8 
               M_IK2   = 0.0_8  
               M_EK    = 0.0_8
               M_EK2   = 0.0_8  
               VAR_IK  = 0.0_8                                                      
               VAR_EK  = 0.0_8 
    
    do j=1,zgrid           
    do i=1,kgrid   
    do ib=1,bgrid          
               optIK(i,j,ib)  = ( optI(i,j,ib) / k(i) )
               optEK(i,j,ib)  = ( pi(i,j,ib)   / k(i) )
               optIK2(i,j,ib) = ( optI(i,j,ib) / k(i) ) ** 2
               optEK2(i,j,ib) = ( pi(i,j,ib)   / k(i) ) ** 2               
    end do
    end do 
    end do                                        
               
    do i=1,kgrid-1
       do ib=1,bgrid
         M_IK   = M_IK   + sum(  ( (optIK(i,:,ib)  + optIK(i+1,:,ib)) /2.0_8 ) * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
         M_IK2  = M_IK2  + sum(  ( (optIK2(i,:,ib) + optIK2(i+1,:,ib))/2.0_8 ) * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )        
         M_EK   = M_EK   + sum(  ( (optEK(i,:,ib)  + optEK(i+1,:,ib)) /2.0_8 ) * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )
         M_EK2  = M_EK2  + sum(  ( (optEK2(i,:,ib) + optEK2(i+1,:,ib))/2.0_8 ) * ( stdis((((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+1:(((i-1)*bgrid*zgrid)+(ib*zgrid))) )  )                   
       end do
    end do
            
         VAR_IK  = M_IK2 - (M_IK**2)   
         VAR_EK  = M_EK2 - (M_EK**2)  

         print *, "STD_IK  = ", (VAR_IK**(0.5)) 
         
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   
               print *, "================================"
               print *, " "
               print *, "w           = ", w  
               print *, "r           = ", r                       
               print *, "L           = ", L_AGG   
               print *, "tol_w       = ", tol_w
               print *, "tol_r       = ", tol_r                                       
               print *, "toleranceA  = ", toleranceA
               print *, "toleranceB  = ", toleranceB
               print *, "toleranceC  = ", toleranceC                                                     
               print *, " "    

               print *, " "
               print *, "========================================================================="                  
               print *, "========================= TAX RATES ====================================="                  
               print *, "========================================================================="   
               print *, " "
               print *, "delta   = ", delta
               print *, "beta    = ", beta
               print *, "psi     = ", psi
               print *, "td      = ", td
               print *, "tg      = ", tg
               print *, "ti      = ", ti  
               print *, "tb      = ", tb  
               print *, "bcost   = ", bcost                   
               print *, " "                                              
               print *, "=========================================================================" 
               print *, "===============  AGGREGATES  ============================================"                      
               print *, "========================================================================="                                                             
               print *, " "
               print *, "V_AGG    = ", V_AGG 
               print *, "PV_AGG   = ", PV_AGG               
               print *, "K_AGG    = ", K_AGG 
               print *, "KP_AGG   = ", KP_AGG    
               print *, "B_AGG    = ", B_AGG 
               print *, "BP_AGG   = ", BP_AGG                                
               print *, "I_AGG    = ", I_AGG 
               print *, "L_AGG    = ", L_AGG
               print *, "Y_AGG    = ", Y_AGG
               print *, "AC_AGG   = ", AC_AGG  
               print *, "AC2_AGG  = ", AC2_AGG 
               print *, "BAC_AGG  = ", BAC_AGG                                
               print *, "C_AGG    = ", C_AGG                           
               print *, "G_AGG    = ", G_AGG  
               print *, "DIV_AGG  = ", DIV_AGG
               print *, "SEQ_AGG  = ", SEQ_AGG  
               print *, "EARN_AGG = ", EARN_AGG                                                      
               print *, " "
               print *, "========================================================================="       
               print *, "======================  TABLE 4  ========================================"       
               print *, "========================================================================="                                         
               print *, " "
               print *, "I/K     = ", I_AGG/K_AGG
               print *, "I/Y     = ", I_AGG/Y_AGG
               print *, "K/Y     = ", K_AGG/Y_AGG    
               print *, "B/Y     = ", B_AGG/Y_AGG                 
               print *, "DIV/ERN = ", DIV_AGG/EARN_AGG                      
               print *, "SEQ/INV = ", SEQ_AGG/I_AGG    
               print *, "DIV/Y   = ", DIV_AGG/Y_AGG  
               print *, "STD_IK  = ", (VAR_IK**(0.5)) 
               print *, "STD_EK  = ", (VAR_EK**(0.5))                               
               print *, "WAGE    = ", w                                                                                                                                                                                                                 
               print *, " "


      OPEN (UNIT=912,  FILE="Agg1_F.txt", STATUS="NEW") 
      OPEN (UNIT=913,  FILE="Agg2_F.txt", STATUS="NEW")
      OPEN (UNIT=9131, FILE="Agg3_F.txt", STATUS="NEW")       

   	        WRITE(912,*) K_AGG  	
 	        WRITE(912,*) L_AGG	
	        WRITE(912,*) Y_AGG
	        WRITE(912,*) I_AGG  	
	        WRITE(912,*) C_AGG   	
	        WRITE(912,*) AC_AGG
	        WRITE(912,*) G_AGG  	
	        WRITE(912,*) DIV_AGG	
	        WRITE(912,*) SEQ_AGG 
	        WRITE(912,*) AC2_AGG
	        WRITE(912,*) BAC_AGG
	        WRITE(912,*) B_AGG	          
	        		        	        	        	        	        	        	        	        
	        WRITE(913,*) V_AGG
	        WRITE(913,*) PV_AGG	        
	        WRITE(913,*) r 
	        WRITE(913,*) w	 
	        WRITE(913,*) ti
	        WRITE(913,*) td	
	        WRITE(913,*) S_AGG	        		        	        	 	 
	        WRITE(913,*) tc
	        WRITE(913,*) tb	
	        
	        WRITE(9131,*) VC_AGG
	        WRITE(9131,*) CONS_AGG		          
		        	        
      OPEN (UNIT=919111, FILE="OptK_stop.txt", STATUS="NEW") 
      OPEN (UNIT=919112, FILE="OptB_stop.txt", STATUS="NEW") 

      do j=1,zgrid   
         do i=1,kgrid  
            do ib=1,bgrid               
	          WRITE(919111,*)  optK(i,j,ib)
	          WRITE(919112,*)  optB(i,j,ib)
	        end do 	        	                        	  	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do 
 
      OPEN (UNIT=916, FILE="Dist_F.txt", STATUS="NEW")        
      OPEN (UNIT=917, FILE="Div_F.txt", STATUS="NEW")  
      OPEN (UNIT=918, FILE="Seq_F.txt", STATUS="NEW")  	             	        	        	        	        	           	              
      
      do j=1,zgrid   
         do i=1,kgrid  
            do ib=1,bgrid    
	          WRITE(917,*)  optD(i,j,ib)	  
	          WRITE(918,*)  optS(i,j,ib)	           
	        end do 	        	                        	  	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do  

      do j=1,zgrid   
         do i=1,kgrid-1 
            do ib=1,bgrid     
	           WRITE(916,*)    stdis( (((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+j )
	        end do
 	     end do     	     	     	     	     	     	     	     	     	
      end do 
      
      OPEN (UNIT=914, FILE="Val_F.txt", STATUS="NEW") 
      OPEN (UNIT=915, FILE="PVal_F.txt", STATUS="NEW")    
         
      do j=1,zgrid   
         do i=1,kgrid  
            do ib=1,bgrid    
              WRITE(914,*)  V(i,j,ib)		
  	          WRITE(915,*)  PV(i,j,ib)
	        end do 	        	                        	  	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do        
      
stop

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxx  Investment Spikes  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    Inactive = 0.0_8
    Pos_Inv  = 0.0_8
    Neg_Inv  = 0.0_8
    Pos_Spi  = 0.0_8
    Neg_Spi  = 0.0_8      
    
    do j=1,zgrid
       do i=1,kgrid-1
          do ib=1,bgrid          
          
          ikc = ((optIK(i,j,ib)+optIK(i+1,j,ib))/2.0_8)
          
          if (ikc.ge.(0.20_8)) then
              Pos_Spi  = Pos_Spi + stdis( (((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+j )
          else
              if (ikc.le.(-0.20_8)) then
                  Neg_Spi  = Neg_Spi + stdis( (((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+j )
              else
                  check = 1
              end if
              check = 1
          end if    
          
          if (ikc.ge.(0.01_8)) then
              Pos_Inv  = Pos_Inv + stdis( (((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+j )
          else
              if (ikc.le.(-0.01_8)) then
                  Neg_Inv  = Neg_Inv + stdis( (((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+j )
              else
                  Inactive = Inactive + stdis( (((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+j )
              end if
              check = 1
          end if            
          
          end do 
       end do
    end do
        
               print *, "========================================================================="       
               print *, "============ INVESTMENT SPIKES  ========================================="       
               print *, "========================================================================="                                         
               print *, " "
               print *, "Inactive = ", Inactive
               print *, "Pos_Inv  = ", Pos_Inv
               print *, "Neg_Inv  = ", Neg_Inv    
               print *, "Pos_Spi  = ", Pos_Spi                      
               print *, "Neg_Spi  = ", Neg_Spi 
               print *, "========================================================================="               
               print *, " "     
                               
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxx  Determination of Regimes  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    check   = 1 - ( (1.0_8-td)/(1.0_8-tg) ) - 0.0000001_8
    control = 0.0000001_8
    
    Regime = 100
    
    do j=1,zgrid
       do i=1,kgrid-1
          do ib=1,bgrid 
          
          LamD_L = optMULT(i,j,ib)
          LamD_H = optMULT(i+1,j,ib)                      
          
          if (LamD_L.gt.check) then
             if (LamD_H.gt.check) then
                 Regime( ((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j ) = 1
             else
                 Regime( ((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j ) = 2
             end if
          else
             if (LamD_L.gt.control) then
                 Regime( ((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j ) = 2
             else
                 Regime( ((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j ) = 3        
             end if    
          end if           
          
          end do                  
       end do
    end do   
    
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxx  Determination of Regimes - td=tg case  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
    
    Regime2 = 100
    
    do j=1,zgrid
       do i=1,kgrid-1
          do ib=1,bgrid

          if (optS(i,j,ib).gt.0) then
             if (optS(i+1,j,ib).gt.0) then
                 Regime2( ((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j ) = 1
             else
                 Regime2( ((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j ) = 2
             end if
          else
                 Regime2( ((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j ) = 3         
          end if 
                    
          end do                  
       end do
    end do     
    
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxx  Regime - Aggregates  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx    
    
    F_Reg1 = 0.0_8
    F_Reg2 = 0.0_8
    F_Reg3 = 0.0_8
    K_Reg1 = 0.0_8
    K_Reg2 = 0.0_8     
    K_Reg3 = 0.0_8
    I_Reg1 = 0.0_8
    I_Reg2 = 0.0_8
    I_Reg3 = 0.0_8
    EK_Reg1 = 0.0_8
    EK_Reg2 = 0.0_8 
    EK_Reg3 = 0.0_8
    IK_Reg1 = 0.0_8      
    IK_Reg2 = 0.0_8
    IK_Reg3 = 0.0_8
    TQ_Reg1 = 0.0_8      
    TQ_Reg2 = 0.0_8
    TQ_Reg3 = 0.0_8    
    
    do j=1,zgrid
       do i=1,kgrid-1
          do ib=1,bgrid
          
          if ( Regime(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j).eq.1 ) then
              F_Reg1  = F_Reg1  +   stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)
              K_Reg1  = K_Reg1  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((k(i)+k(i+1))/2.0_8) )
              I_Reg1  = I_Reg1  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
              EK_Reg1 = EK_Reg1 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((pi(i,j,ib)+pi(i+1,j,ib))/2.0_8) )
              IK_Reg1 = IK_Reg1 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
              TQ_Reg1 = TQ_Reg1 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((V(i,j,ib)+V(i+1,j,ib))/2.0_8) )
          else
             if ( Regime(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j).eq.2 ) then
                 F_Reg2  = F_Reg2  +   stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)
                 K_Reg2  = K_Reg2  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((k(i)+k(i+1))/2.0_8) )
                 I_Reg2  = I_Reg2  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
                 EK_Reg2 = EK_Reg2 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((pi(i,j,ib)+pi(i+1,j,ib))/2.0_8) )
                 IK_Reg2 = IK_Reg2 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
                 TQ_Reg2 = TQ_Reg2 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((V(i,j,ib)+V(i+1,j,ib))/2.0_8) )                 
             else
                 F_Reg3  = F_Reg3  +   stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)
                 K_Reg3  = K_Reg3  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((k(i)+k(i+1))/2.0_8) )
                 I_Reg3  = I_Reg3  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
                 EK_Reg3 = EK_Reg3 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((pi(i,j,ib)+pi(i+1,j,ib))/2.0_8) )
                 IK_Reg3 = IK_Reg3 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
                 TQ_Reg3 = TQ_Reg3 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((V(i,j,ib)+V(i+1,j,ib))/2.0_8) )                 
             end if          
          end if          
                       
          end do                   
       end do
    end do 
        
         K_Reg1 = K_Reg1 / K_AGG   
         K_Reg2 = K_Reg2 / K_AGG  
         K_Reg3 = K_Reg3 / K_AGG
         
         I_Reg1 = I_Reg1 / I_AGG 
         I_Reg2 = I_Reg2 / I_AGG
         I_Reg3 = I_Reg3 / I_AGG       
         
         EK_Reg1 = EK_Reg1 / (K_AGG*K_Reg1)   
         EK_Reg2 = EK_Reg2 / (K_AGG*K_Reg2)  
         EK_Reg3 = EK_Reg3 / (K_AGG*K_Reg3)
         
         IK_Reg1 = IK_Reg1 / (K_AGG*K_Reg1)   
         IK_Reg2 = IK_Reg2 / (K_AGG*K_Reg2)  
         IK_Reg3 = IK_Reg3 / (K_AGG*K_Reg3)  
         
         TQ_Reg1 = TQ_Reg1 / (K_AGG*K_Reg1)   
         TQ_Reg2 = TQ_Reg2 / (K_AGG*K_Reg2)  
         TQ_Reg3 = TQ_Reg3 / (K_AGG*K_Reg3)                                                        
    
    
               print *, "========================================================================="       
               print *, "======================  TABLE 5  ========================================"       
               print *, "========================================================================="             
               print *, "F  = ", F_Reg1, F_Reg2, F_Reg3      
               print *, "K  = ", K_Reg1, K_Reg2, K_Reg3 
               print *, "I  = ", I_Reg1, I_Reg2, I_Reg3   
               print *, "EK = ", EK_Reg1, EK_Reg2, EK_Reg3 
               print *, "IK = ", IK_Reg1, IK_Reg2, IK_Reg3 
               print *, "TQ = ", TQ_Reg1, TQ_Reg2, TQ_Reg3                                                                                                        
               print *, "=========================================================================" 
               print *, " "  
               

               OPEN (UNIT=1000, FILE="STAT_1.txt", STATUS="NEW")   

	           WRITE(1000,*) "========================================================================="       
	           WRITE(1000,*) "======================  TAX RATES  ======================================"       
	           WRITE(1000,*) "========================================================================="                                         
	           WRITE(1000,*) "delta   = ", delta
	           WRITE(1000,*) "beta    = ", beta
	           WRITE(1000,*) "psi     = ", psi  
	           WRITE(1000,*) "td      = ", td    
	           WRITE(1000,*) "tg      = ", tg  	     	     
	           WRITE(1000,*) "ti      = ", ti    
	           WRITE(1000,*) "tb      = ", tb    	                                                                                                                                                                                                   
	           WRITE(1000,*) " "
               WRITE(1000,*) "=========================================================================" 
               WRITE(1000,*) "=====================  AGGREGATES  ======================================"                      
               WRITE(1000,*) "========================================================================="                                                             
               WRITE(1000,*)  " "
               WRITE(1000,*)  "V_AGG    = ", V_AGG 
               WRITE(1000,*)  "PV_AGG   = ", PV_AGG               
               WRITE(1000,*)  "K_AGG    = ", K_AGG 
               WRITE(1000,*)  "KP_AGG   = ", KP_AGG  
               WRITE(1000,*)  "B_AGG    = ", B_AGG 
               WRITE(1000,*)  "BP_AGG   = ", BP_AGG                                
               WRITE(1000,*)  "I_AGG    = ", I_AGG 
               WRITE(1000,*)  "L_AGG    = ", L_AGG
               WRITE(1000,*)  "Y_AGG    = ", Y_AGG
               WRITE(1000,*)  "AC_AGG   = ", AC_AGG  
               WRITE(1000,*)  "AC2_AGG  = ", AC2_AGG
               WRITE(1000,*)  "BAC_AGG  = ", BAC_AGG                               
               WRITE(1000,*)  "C_AGG    = ", C_AGG                           
               WRITE(1000,*)  "G_AGG    = ", G_AGG  
               WRITE(1000,*)  "DIV_AGG  = ", DIV_AGG
               WRITE(1000,*)  "SEQ_AGG  = ", SEQ_AGG  
               WRITE(1000,*)  "EARN_AGG = ", EARN_AGG                                                      
               WRITE(1000,*)  " "	     
	           WRITE(1000,*) "========================================================================="       
	           WRITE(1000,*) "======================  TABLE 4  ========================================"       
	           WRITE(1000,*) "========================================================================="                                         
               WRITE(1000,*)  "I/K     = ", I_AGG/K_AGG
               WRITE(1000,*)  "I/Y     = ", I_AGG/Y_AGG
               WRITE(1000,*)  "K/Y     = ", K_AGG/Y_AGG  
               WRITE(1000,*)  "B/Y     = ", B_AGG/Y_AGG                   
               WRITE(1000,*)  "DIV/ERN = ", DIV_AGG/EARN_AGG                      
               WRITE(1000,*)  "SEQ/INV = ", SEQ_AGG/I_AGG    
               WRITE(1000,*)  "DIV/Y   = ", DIV_AGG/Y_AGG  
               WRITE(1000,*)  "STD_IK  = ", (VAR_IK**(0.5)) 
               WRITE(1000,*)  "STD_EK  = ", (VAR_EK**(0.5))                               
               WRITE(1000,*)  "WAGE    = ", w                                                                                                                                                                                                                 
               WRITE(1000,*)  " " 
	           WRITE(1000,*) "========================================================================="       
	           WRITE(1000,*) "======================  TABLE 5  ========================================"       
	           WRITE(1000,*) "========================================================================="             
	           WRITE(1000,*) "F  = ", F_Reg1, F_Reg2, F_Reg3 
	           WRITE(1000,*) "K  = ", K_Reg1, K_Reg2, K_Reg3 
	           WRITE(1000,*) "I  = ", I_Reg1, I_Reg2, I_Reg3 
	           WRITE(1000,*) "EK = ", EK_Reg1, EK_Reg2, EK_Reg3 
	           WRITE(1000,*) "IK = ", IK_Reg1, IK_Reg2, IK_Reg3 
	           WRITE(1000,*) "TQ = ", TQ_Reg1, TQ_Reg2, TQ_Reg3                                                                            
	           WRITE(1000,*) "========================================================================="  

    
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxx  Regime - Aggregates  - td=tg case  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx    
    
    F_Reg1 = 0.0_8
    F_Reg2 = 0.0_8
    F_Reg3 = 0.0_8
    K_Reg1 = 0.0_8
    K_Reg2 = 0.0_8     
    K_Reg3 = 0.0_8
    I_Reg1 = 0.0_8
    I_Reg2 = 0.0_8
    I_Reg3 = 0.0_8
    EK_Reg1 = 0.0_8
    EK_Reg2 = 0.0_8 
    EK_Reg3 = 0.0_8
    IK_Reg1 = 0.0_8      
    IK_Reg2 = 0.0_8
    IK_Reg3 = 0.0_8
    TQ_Reg1 = 0.0_8      
    TQ_Reg2 = 0.0_8
    TQ_Reg3 = 0.0_8    
    
    do j=1,zgrid
       do i=1,kgrid-1
         do ib=1,bgrid
          
         if ( Regime2(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j).eq.1 ) then
              F_Reg1  = F_Reg1  +   stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)
              K_Reg1  = K_Reg1  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((k(i)+k(i+1))/2.0_8) )
              I_Reg1  = I_Reg1  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
              EK_Reg1 = EK_Reg1 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((pi(i,j,ib)+pi(i+1,j,ib))/2.0_8) )
              IK_Reg1 = IK_Reg1 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
              TQ_Reg1 = TQ_Reg1 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((V(i,j,ib)+V(i+1,j,ib))/2.0_8) )
         else
            if ( Regime2(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j).eq.2 ) then
                        
                 F_Reg1  = F_Reg1  +   (stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)/2.0_8)
                 K_Reg1  = K_Reg1  + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((k(i)+k(i+1))/2.0_8) )/2.0_8)
                 I_Reg1  = I_Reg1  + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )/2.0_8)
                 EK_Reg1 = EK_Reg1 + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((pi(i,j,ib)+pi(i+1,j,ib))/2.0_8) )/2.0_8)
                 IK_Reg1 = IK_Reg1 + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )/2.0_8)
                 TQ_Reg1 = TQ_Reg1 + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((V(i,j,ib)+V(i+1,j,ib))/2.0_8) )/2.0_8)  
                 
                 F_Reg3  = F_Reg3  +   (stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)/2.0_8)
                 K_Reg3  = K_Reg3  + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((k(i)+k(i+1))/2.0_8) )/2.0_8)
                 I_Reg3  = I_Reg3  + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )/2.0_8)
                 EK_Reg3 = EK_Reg3 + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((pi(i,j,ib)+pi(i+1,j,ib))/2.0_8) )/2.0_8)
                 IK_Reg3 = IK_Reg3 + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )/2.0_8)
                 TQ_Reg3 = TQ_Reg3 + (( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((V(i,j,ib)+V(i+1,j,ib))/2.0_8) )/2.0_8)                               
        
            else
                 F_Reg3  = F_Reg3  +   stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)
                 K_Reg3  = K_Reg3  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((k(i)+k(i+1))/2.0_8) )
                 I_Reg3  = I_Reg3  + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
                 EK_Reg3 = EK_Reg3 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((pi(i,j,ib)+pi(i+1,j,ib))/2.0_8) )
                 IK_Reg3 = IK_Reg3 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((optI(i,j,ib)+optI(i+1,j,ib))/2.0_8) )
                 TQ_Reg3 = TQ_Reg3 + ( stdis(((i-1)*(bgrid)*zgrid)+((ib-1)*zgrid)+j)*((V(i,j,ib)+V(i+1,j,ib))/2.0_8) )                 
            end if          
         end if          
         
         end do                   
       end do
    end do 
        
         K_Reg1 = K_Reg1 / K_AGG   
         K_Reg2 = K_Reg2 / K_AGG  
         K_Reg3 = K_Reg3 / K_AGG
         
         I_Reg1 = I_Reg1 / I_AGG 
         I_Reg2 = I_Reg2 / I_AGG
         I_Reg3 = I_Reg3 / I_AGG       
         
         EK_Reg1 = EK_Reg1 / (K_AGG*K_Reg1)   
         EK_Reg2 = EK_Reg2 / (K_AGG*K_Reg2)  
         EK_Reg3 = EK_Reg3 / (K_AGG*K_Reg3)
         
         IK_Reg1 = IK_Reg1 / (K_AGG*K_Reg1)   
         IK_Reg2 = IK_Reg2 / (K_AGG*K_Reg2)  
         IK_Reg3 = IK_Reg3 / (K_AGG*K_Reg3)  
         
         TQ_Reg1 = TQ_Reg1 / (K_AGG*K_Reg1)   
         TQ_Reg2 = TQ_Reg2 / (K_AGG*K_Reg2)  
         TQ_Reg3 = TQ_Reg3 / (K_AGG*K_Reg3)                                                        
    
    
               print *, "========================================================================="       
               print *, "======================  TABLE 5 - td=tg case  ==========================="       
               print *, "========================================================================="             
               print *, "F  = ", F_Reg1, F_Reg2, F_Reg3      
               print *, "K  = ", K_Reg1, K_Reg2, K_Reg3 
               print *, "I  = ", I_Reg1, I_Reg2, I_Reg3   
               print *, "EK = ", EK_Reg1, EK_Reg2, EK_Reg3 
               print *, "IK = ", IK_Reg1, IK_Reg2, IK_Reg3 
               print *, "TQ = ", TQ_Reg1, TQ_Reg2, TQ_Reg3                                                                                                        
               print *, "=========================================================================" 
               print *, " "  
               

               OPEN (UNIT=2000, FILE="STAT_2.txt", STATUS="NEW")   

	           WRITE(2000,*) "========================================================================="       
	           WRITE(2000,*) "======================  TAX RATES  ======================================"       
	           WRITE(2000,*) "========================================================================="                                         
	           WRITE(2000,*) "delta   = ", delta
	           WRITE(2000,*) "beta    = ", beta
	           WRITE(2000,*) "psi     = ", psi  
	           WRITE(2000,*) "td      = ", td    
	           WRITE(2000,*) "tg      = ", tg  	     	     
	           WRITE(2000,*) "ti      = ", ti    
	           WRITE(2000,*) "tb      = ", tb    	                                                                                                                                                                                                   
	           WRITE(2000,*) " "
               WRITE(2000,*) "=========================================================================" 
               WRITE(2000,*) "=====================  AGGREGATES  ======================================"                      
               WRITE(2000,*) "========================================================================="                                                             
               WRITE(2000,*)  " "
               WRITE(2000,*)  "V_AGG    = ", V_AGG 
               WRITE(2000,*)  "PV_AGG   = ", PV_AGG               
               WRITE(2000,*)  "K_AGG    = ", K_AGG 
               WRITE(2000,*)  "KP_AGG   = ", KP_AGG                                
               WRITE(2000,*)  "B_AGG    = ", B_AGG  
               WRITE(2000,*)  "BP_AGG   = ", BP_AGG   
               WRITE(2000,*)  "I_AGG    = ", I_AGG 
               WRITE(2000,*)  "L_AGG    = ", L_AGG
               WRITE(2000,*)  "Y_AGG    = ", Y_AGG
               WRITE(2000,*)  "AC_AGG   = ", AC_AGG
               WRITE(2000,*)  "AC2_AGG  = ", AC2_AGG   
               WRITE(2000,*)  "BAC_AGG  = ", BAC_AGG                                  
               WRITE(2000,*)  "C_AGG    = ", C_AGG                           
               WRITE(2000,*)  "G_AGG    = ", G_AGG  
               WRITE(2000,*)  "DIV_AGG  = ", DIV_AGG
               WRITE(2000,*)  "SEQ_AGG  = ", SEQ_AGG  
               WRITE(2000,*)  "EARN_AGG = ", EARN_AGG                                                      
               WRITE(2000,*)  " "	     
	           WRITE(2000,*) "========================================================================="       
	           WRITE(2000,*) "======================  TABLE 4  ========================================"       
	           WRITE(2000,*) "========================================================================="                                         
               WRITE(2000,*)  "I/K     = ", I_AGG/K_AGG
               WRITE(2000,*)  "I/Y     = ", I_AGG/Y_AGG
               WRITE(2000,*)  "K/Y     = ", K_AGG/Y_AGG 
               WRITE(2000,*)  "B/Y     = ", B_AGG/Y_AGG                   
               WRITE(2000,*)  "DIV/ERN = ", DIV_AGG/EARN_AGG                      
               WRITE(2000,*)  "SEQ/INV = ", SEQ_AGG/I_AGG    
               WRITE(2000,*)  "DIV/Y   = ", DIV_AGG/Y_AGG  
               WRITE(2000,*)  "STD_IK  = ", (VAR_IK**(0.5)) 
               WRITE(2000,*)  "STD_EK  = ", (VAR_EK**(0.5))                               
               WRITE(2000,*)  "WAGE    = ", w                                                                                                                                                                                                                 
               WRITE(2000,*)  " " 
	           WRITE(2000,*) "========================================================================="       
	           WRITE(2000,*) "======================  TABLE 5  ========================================"       
	           WRITE(2000,*) "========================================================================="             
	           WRITE(2000,*) "F  = ", F_Reg1, F_Reg2, F_Reg3 
	           WRITE(2000,*) "K  = ", K_Reg1, K_Reg2, K_Reg3 
	           WRITE(2000,*) "I  = ", I_Reg1, I_Reg2, I_Reg3 
	           WRITE(2000,*) "EK = ", EK_Reg1, EK_Reg2, EK_Reg3 
	           WRITE(2000,*) "IK = ", IK_Reg1, IK_Reg2, IK_Reg3 
	           WRITE(2000,*) "TQ = ", TQ_Reg1, TQ_Reg2, TQ_Reg3                                                                            
	           WRITE(2000,*) "========================================================================="                                
    
  
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

      OPEN (UNIT=912,  FILE="Agg1_F.txt", STATUS="NEW") 
      OPEN (UNIT=913,  FILE="Agg2_F.txt", STATUS="NEW")
      OPEN (UNIT=9131, FILE="Agg3_F.txt", STATUS="NEW")       
      OPEN (UNIT=9132, FILE="Agg4_F.txt", STATUS="NEW")    

   	        WRITE(912,*) K_AGG  	
 	        WRITE(912,*) L_AGG	
	        WRITE(912,*) Y_AGG
	        WRITE(912,*) I_AGG  	
	        WRITE(912,*) C_AGG   	
	        WRITE(912,*) AC_AGG
	        WRITE(912,*) G_AGG  	
	        WRITE(912,*) DIV_AGG	
	        WRITE(912,*) SEQ_AGG 
	        WRITE(912,*) AC2_AGG
	        WRITE(912,*) BAC_AGG
	        WRITE(912,*) B_AGG	          
	        		        	        	        	        	        	        	        	        
	        WRITE(913,*) V_AGG
	        WRITE(913,*) PV_AGG	        
	        WRITE(913,*) r 
	        WRITE(913,*) w	 
	        WRITE(913,*) ti
	        WRITE(913,*) td	
	        WRITE(913,*) S_AGG	        		        	        	 	 
	        WRITE(913,*) tc
	        WRITE(913,*) tb	
	        
	        WRITE(9131,*) VC_AGG
	        WRITE(9131,*) CONS_AGG		          

	        WRITE(9132,*) Inactive
	        WRITE(9132,*) Pos_Inv	
	        WRITE(9132,*) Neg_Inv	
	        WRITE(9132,*) Pos_Spi	
	        WRITE(9132,*) Neg_Spi		        	        

      OPEN (UNIT=914, FILE="Val_F.txt", STATUS="NEW") 
      OPEN (UNIT=915, FILE="PVal_F.txt", STATUS="NEW")    
      OPEN (UNIT=916, FILE="Dist_F.txt", STATUS="NEW")  
      OPEN (UNIT=91688, FILE="OptIK_stdis_F_.txt", STATUS="NEW")        
      OPEN (UNIT=917, FILE="Div_F.txt", STATUS="NEW")  
      OPEN (UNIT=918, FILE="Seq_F.txt", STATUS="NEW")  	             	        	        	        	        	           	             
      OPEN (UNIT=919, FILE="OptK_F.txt", STATUS="NEW")                               
      OPEN (UNIT=9191, FILE="OptMULT_F.txt", STATUS="NEW")        
      OPEN (UNIT=91999, FILE="OptQQQ_F.txt", STATUS="NEW")     
      
      do j=1,zgrid   
         do i=1,kgrid  
            do ib=1,bgrid    
              WRITE(914,*)  V(i,j,ib)		
  	          WRITE(915,*)  PV(i,j,ib)
	          WRITE(917,*)  optD(i,j,ib)	  
	          WRITE(918,*)  optS(i,j,ib)	           
	          WRITE(919,*)  optK(i,j,ib)
	          WRITE(9191,*) optMULT(i,j,ib)	 
	          WRITE(91999,*)  qqq(i,j,ib) 
	        end do 	        	                        	  	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do  

      do j=1,zgrid   
         do i=1,kgrid-1 
            do ib=1,bgrid     
	           WRITE(916,*)    stdis( (((i-1)*bgrid*zgrid)+((ib-1)*zgrid))+j )
	           WRITE(91688,*)  ( (optIK(i,j,ib)  + optIK(i+1,j,ib)) / 2.0_8 ) 
	        end do
 	     end do     	     	     	     	     	     	     	     	     	
      end do  	

      OPEN (UNIT=933,  FILE="OptShare_F.txt", STATUS="NEW")  
      OPEN (UNIT=9335, FILE="OptCons_F.txt", STATUS="NEW")
      OPEN (UNIT=9336, FILE="VC_F.txt", STATUS="NEW")           
      OPEN (UNIT=934,  FILE="DistC_F.txt", STATUS="NEW")  
      
      do j=1,egrid   
         do i=1,sgrid     
            WRITE(933,*)   optShare(i,j)
            WRITE(9335,*)  optCons(i,j)	
            WRITE(9336,*)  VC(i,j)	                  			        	  	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do   

      do j=1,egrid   
         do i=1,sgrid-1     
	        WRITE(934,*)  stdisC ( ((i-1)*egrid) + j )		            
	     end do     	     	     	     	     	     	     	     	     	
      end do            	            	
    
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

print *, "DONE"


END PROGRAM OLG

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx