
!===========================================================================================
!MAIN CODE.   ( LOGNORMAL  )
!
!Last modified: March 24 2013
!===========================================================================================

PROGRAM OLG  

    INCLUDE 'link_fnl_static.h'
	USE PARAME	
	USE UTILITIES
	USE LSARG_INT
	USE WRRRN_INT
	
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxx   DEFINE VARIABLES   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	 
	Real*8  :: k(kgrid), kk(kgrid), z(zgrid), tz(zgrid,zgrid), stdisT(zgrid*(kgrid-1),Ts), stdisT_C(egrid*(sgrid-1),Ts)
    Real*8  :: s(sgrid), e(egrid), te(egrid,egrid), ss(sgrid)
    Real*8  :: trans( (kgrid-1)*zgrid , (kgrid-1)*zgrid ) , transC( (sgrid-1)*egrid , (sgrid-1)*egrid )
    Real*8  :: stdise(egrid), stdise2(egrid), wealth(sgrid,egrid), pi(kgrid,zgrid), VnTR(Ts+1)       
	Real*8  :: rp(Ts-1), rp2(Ts-1), wp(Ts), wp2(Ts), rf(Ts-1), RR(Ts-1)    
	Real*8  :: td(Ts), tg(Ts), tc(Ts), ti(Ts)    
    Integer :: x1, x2, xx(1), ones(kgrid)=1, onesC(sgrid)=1, sorun(2) 	     
    Real*8  :: Vi(kgrid,zgrid), PVi(kgrid,zgrid), disti(zgrid*(kgrid-1)), divi(kgrid,zgrid), seqi(kgrid,zgrid), optin(kgrid,zgrid), optMin(kgrid,zgrid), OptShare_I(sgrid,egrid), distCi(egrid*(sgrid-1)), OptCons_I(sgrid,egrid), VC_I(sgrid,egrid)	  
	Real*8  :: Vf(kgrid,zgrid), PVf(kgrid,zgrid), distf(zgrid*(kgrid-1)), divf(kgrid,zgrid), seqf(kgrid,zgrid), optf(kgrid,zgrid), optMf(kgrid,zgrid), OptShare_F(sgrid,egrid), distCf(egrid*(sgrid-1))  , OptCons_F(sgrid,egrid), VC_F(sgrid,egrid)  	
	Real*8  :: optK(kgrid,zgrid,Ts), optMULT(kgrid,zgrid,Ts), optS(kgrid,zgrid,Ts), optD(kgrid,zgrid,Ts), optPi(kgrid,zgrid,Ts), optPay(kgrid,zgrid,Ts), optShare(sgrid,egrid,Ts), optCons(sgrid,egrid,Ts), VC(sgrid,egrid,Ts)
    Real*8  :: optL(kgrid,zgrid,Ts), optY(kgrid,zgrid,Ts), optG(kgrid,zgrid,Ts), optI(kgrid,zgrid,Ts), optAC(kgrid,zgrid,Ts), V(kgrid,zgrid,Ts), PV(kgrid,zgrid,Ts) 	
	Real*8  :: K_AGG_T(Ts), KP_AGG_T(Ts), L_AGG_T(Ts), Y_AGG_T(Ts), G_AGG_T(Ts), I_AGG_T(Ts), DIV_AGG_T(Ts), SEQ_AGG_T(Ts), AC_AGG_T(Ts), C_AGG_T(Ts), V_AGG_T(Ts), PV_AGG_T(Ts), CAP_GAIN(Ts), S_AGG_T(Ts), CONS_AGG_T(Ts), VC_AGG_T(Ts), VC_AGG_TP(Ts) 
    Real*8  :: lllp(zgrid), prop(zgrid), piip(zgrid), kkkp(zgrid), xxxp(zgrid), payp(zgrid), MBterm(zgrid), MB2(zgrid), mult(zgrid)	                  
    Real*8  :: wwwp(egrid), sssp(egrid), cccp(egrid), mu1p(egrid)   
    Real*8  :: CE_TOTAL_T(Ts), CE_AGGREGATE_T(Ts) , CE_DISTRIBUTION_T(Ts)          
	
	Real*8  :: stdisC(egrid*(sgrid-1)), stat1C(egrid*(sgrid-1)) , stdis(zgrid*(kgrid-1)), stat1(zgrid*(kgrid-1))	           	 
	Real*8  :: VCp(sgrid,egrid,Ts) 
        
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxx   ALLOCATE VARIABLES   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

            ss(1)     = share_min 
            ss(sgrid) = share_max
            print *, sqrt(ss(sgrid))
	    do i=2,sgrid
			ss(i)     = sqrt(ss(1)) + ( (i-1)*(sqrt(ss(sgrid))-sqrt(ss(1)))/(sgrid-1) ) 	
        end do 
        do i=1,sgrid
			s(i)      = ss(i)**2						
        end do 

        print *, "==========================="        
        print *, "s - 1   = ", s(1)
        print *, "s - 4   = ", s(4)
        print *, "s - 16  = ", s(16)
        print *, "s - 67  = ", s(67)
        print *, "s - 68  = ", s(68)
        print *, "s - 69  = ", s(69)                               
        print *, "s - 70  = ", s(70) 
        print *, "s - 170 = ", s(170) 
        print *, "s - 270 = ", s(270) 
        print *, "s - 300 = ", s(300) 
        print *, "==========================="  
                                        
			e(1)  = (0.167_8) * 1.00_8  ! 0.167_8  ! 1.00_8
			e(2)  = (0.167_8) * 5.29_8  ! 0.839_8  ! 5.29_8
			e(3)  = (0.167_8) * 46.55_8 ! 5.087_8  ! 46.55_8
			
			te(1,1)  = 0.992_8
            te(1,2)  = 0.008_8
		    te(1,3)  = 0.000_8

			te(2,1)  = 0.009_8
            te(2,2)  = 0.980_8
		    te(2,3)  = 0.011_8           

			te(3,1)  = 0.000_8
            te(3,2)  = 0.083_8
		    te(3,3)  = 0.917_8
		    		   		   
	     stdise = 1.0_8
	     stdise = stdise / ( egrid )
	   
	     prdiff = 1.0_8
	 	 DO 
			if (prdiff.lt.toldist) exit
			stdise2 = MATMUL(stdise,te)			
			prdiff  = MAXVAL(abs(stdise2-stdise))			
			stdise=stdise2
	  	 END DO                                 		             

         print *, "--------------------------------------"             
         print *, stdise(1), stdise(2), stdise(3)   
         print *, "--------------------------------------"            
         lss  = ( stdise(1)*e(1) ) + ( stdise(2)*e(2) ) + ( stdise(3)*e(3) )   
         print *, "lss old  = ", lss          
         e(1) = LLL*e(1)/lss 
         e(2) = LLL*e(2)/lss 
         e(3) = LLL*e(3)/lss   
         lss  = ( stdise(1)*e(1) ) + ( stdise(2)*e(2) ) + ( stdise(3)*e(3) )                           

         print *, "--------------------------------------"             
         print *, "lss  = ", lss
         print *, "e(1) = ", e(1)
         print *, "e(2) = ", e(2)
         print *, "e(3) = ", e(3)     
         print *, "--------------------------------------"    
            
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx            
             
            kk(1)     = k_min 
            kk(kgrid) = k_max
	        do i=2,kgrid
			    kk(i)     = (kk(1)**curve) + ( (i-1)*((kk(kgrid)**curve)-(kk(1)**curve))/(kgrid-1) ) 	
            end do 
            do i=1,kgrid
			    k(i)      = ( kk(i)**(1.0_8/curve) )						
            end do 
            
                k(1) = k(2) / 2.0_8

         OPEN (UNIT=119191, FILE="kkkkk.txt", STATUS="NEW")        
      
         do i=1,kgrid     
	        WRITE(119191,*) k(i)	        	  	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	

               
        print *, "--------------------------------------"             
        print *, "k - 1   = ", k(1)
        print *, "k - 2   = ", k(2)        
        print *, "k - 199 = ", k(199)
        print *, "k - 200 = ", k(200)
        print *, "k - 201 = ", k(201)  
        print *, "k - 202 = ", k(202)                
        print *, "k - 299 = ", k(299)
        print *, "k - 300 = ", k(300)
        print *, "k - 301 = ", k(301)
        print *, "k - 399 = ", k(399)        
        print *, "k - 400 = ", k(400)                                                         
        print *, "--------------------------------------"            
        
			z(1)  = 0.3586721077352130_8
			z(2)  = 0.4696513091569100_8
			z(3)  = 0.5920330886999700_8
			z(4)  = 0.7339431549664090_8
			z(5)  = 0.9027393336554150_8
			z(6)  = 1.1077394799568000_8
			z(7)  = 1.3625033399838300_8
			z(8)  = 1.6890947804891700_8
			z(9)  = 2.1292392472942100_8
			z(10) = 2.7880617935817900_8
			
			tz(1,1)  = 0.30815400473981700000_8
            tz(1,2)  = 0.46324670264632000000_8
		    tz(1,3)  = 0.19537690616878300000_8
            tz(1,4)  = 0.03112261061973130000_8
            tz(1,5)  = 0.00204418744296803000_8
            tz(1,6)  = 0.00005502805600693310_8
            tz(1,7)  = 0.00000055855473248835_8
            tz(1,8)  = 0.00000000177046611372_8
            tz(1,9)  = 0.00000000000117482991_8
            tz(1,10) = 1.0_8-tz(1,1)-tz(1,2)-tz(1,3)-tz(1,4)-tz(1,5)-tz(1,6)-tz(1,7)-tz(1,8)-tz(1,9)

			tz(2,1)  = 0.06217460284230930000_8
            tz(2,2)  = 0.32689158001146200000_8
		    tz(2,3)  = 0.40415217795807000000_8
            tz(2,4)  = 0.17463777751912100000_8
            tz(2,5)  = 0.02999895144847120000_8
            tz(2,6)  = 0.00208897775100448000_8
            tz(2,7)  = 0.00005545472577719280_8
            tz(2,8)  = 0.00000047681611660071_8
            tz(2,9)  = 0.00000000092750999471_8
            tz(2,10) = 1.0_8-tz(2,1)-tz(2,2)-tz(2,3)-tz(2,4)-tz(2,5)-tz(2,6)-tz(2,7)-tz(2,8)-tz(2,9)

			tz(3,1)  = 0.00737068273969328000_8
            tz(3,2)  = 0.11360010435705300000_8
		    tz(3,3)  = 0.35378864171176500000_8
            tz(3,4)  = 0.36026446601983000000_8
            tz(3,5)  = 0.14133297498425900000_8
            tz(3,6)  = 0.02226575981046680000_8
            tz(3,7)  = 0.00134988403310257000_8
            tz(3,8)  = 0.00002735225237348440_8
            tz(3,9)  = 0.00000013402466585392_8
            tz(3,10) = 1.0_8-tz(3,1)-tz(3,2)-tz(3,3)-tz(3,4)-tz(3,5)-tz(3,6)-tz(3,7)-tz(3,8)-tz(3,9)

			tz(4,1)  = 0.00054076379106186700_8
            tz(4,2)  = 0.02260836195686510000_8
		    tz(4,3)  = 0.16592755868573500000_8
            tz(4,4)  = 0.37430705948536200000_8
            tz(4,5)  = 0.31596216614576700000_8
            tz(4,6)  = 0.10617469837734600000_8
            tz(4,7)  = 0.01385048459841770000_8
            tz(4,8)  = 0.00062171816331514200_8
            tz(4,9)  = 0.00000717909109014033_8
            tz(4,10) = 1.0_8-tz(4,1)-tz(4,2)-tz(4,3)-tz(4,4)-tz(4,5)-tz(4,6)-tz(4,7)-tz(4,8)-tz(4,9)

			tz(5,1)  = 0.00002451717177954580_8
            tz(5,2)  = 0.00268074216804944000_8
		    tz(5,3)  = 0.04493230152833390000_8
            tz(5,4)  = 0.21809873746772300000_8
            tz(5,5)  = 0.38517782734297500000_8
            tz(5,6)  = 0.26853080207120900000_8
            tz(5,7)  = 0.07328905213427480000_8
            tz(5,8)  = 0.00707868658161891000_8
            tz(5,9)  = 0.00018667354940234700_8
            tz(5,10) = 1.0_8-tz(5,1)-tz(5,2)-tz(5,3)-tz(5,4)-tz(5,5)-tz(5,6)-tz(5,7)-tz(5,8)-tz(5,9)

            tz(6,1)  = tz(5,10)
            tz(6,2)  = tz(5,9)
            tz(6,3)  = tz(5,8)
            tz(6,4)  = tz(5,7)
            tz(6,5)  = tz(5,6)
            tz(6,6)  = tz(5,5)
            tz(6,7)  = tz(5,4)
            tz(6,8)  = tz(5,3)
            tz(6,9)  = tz(5,2)
            tz(6,10) = tz(5,1)
            
            tz(7,1)  = tz(4,10)
            tz(7,2)  = tz(4,9)
            tz(7,3)  = tz(4,8)
            tz(7,4)  = tz(4,7)
            tz(7,5)  = tz(4,6)
            tz(7,6)  = tz(4,5)
            tz(7,7)  = tz(4,4)
            tz(7,8)  = tz(4,3)
            tz(7,9)  = tz(4,2)
            tz(7,10) = tz(4,1)
            
            tz(8,1)  = tz(3,10)
            tz(8,2)  = tz(3,9)
            tz(8,3)  = tz(3,8)
            tz(8,4)  = tz(3,7)
            tz(8,5)  = tz(3,6)
            tz(8,6)  = tz(3,5)
            tz(8,7)  = tz(3,4)
            tz(8,8)  = tz(3,3)
            tz(8,9)  = tz(3,2)
            tz(8,10) = tz(3,1)
            
            tz(9,1)  = tz(2,10)
            tz(9,2)  = tz(2,9)
            tz(9,3)  = tz(2,8)
            tz(9,4)  = tz(2,7)
            tz(9,5)  = tz(2,6)
            tz(9,6)  = tz(2,5)
            tz(9,7)  = tz(2,4)
            tz(9,8)  = tz(2,3)
            tz(9,9)  = tz(2,2)
            tz(9,10) = tz(2,1)
            
            tz(10,1)  = tz(1,10)
            tz(10,2)  = tz(1,9)
            tz(10,3)  = tz(1,8)
            tz(10,4)  = tz(1,7)
            tz(10,5)  = tz(1,6)
            tz(10,6)  = tz(1,5)
            tz(10,7)  = tz(1,4)
            tz(10,8)  = tz(1,3)
            tz(10,9)  = tz(1,2)
            tz(10,10) = tz(1,1)                      

!xxxxxxxxxxxx LOAD S.S. 1 xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        
      OPEN (UNIT=812,  FILE="Agg1_I.txt", STATUS="OLD", ACTION="READ") 
      OPEN (UNIT=813,  FILE="Agg2_I.txt", STATUS="OLD", ACTION="READ")
      OPEN (UNIT=8131, FILE="Agg3_I.txt", STATUS="OLD", ACTION="READ")       
	        	        	        	          	        
      OPEN (UNIT=814,  FILE="Val_I.txt", STATUS="OLD", ACTION="READ") 
      OPEN (UNIT=815,  FILE="PVal_I.txt", STATUS="OLD", ACTION="READ")    
      OPEN (UNIT=816,  FILE="Dist_I.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=817,  FILE="Div_I.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=818,  FILE="Seq_I.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=819,  FILE="OptK_I.txt", STATUS="OLD", ACTION="READ") 
      OPEN (UNIT=8191, FILE="OptMULT_I.txt", STATUS="OLD", ACTION="READ") 
      
      OPEN (UNIT=830,  FILE="OptShare_I.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=8301,  FILE="OptCons_I.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=8302,  FILE="VC_I.txt", STATUS="OLD", ACTION="READ")           
      OPEN (UNIT=831,  FILE="DistC_I.txt", STATUS="OLD", ACTION="READ")   
                      
   	        READ(812,*) K_AGG_i  	
 	        READ(812,*) L_AGG_i	
	        READ(812,*) Y_AGG_i
	        READ(812,*) I_AGG_i  	
	        READ(812,*) C_AGG_i   	
	        READ(812,*) AC_AGG_i
	        READ(812,*) G_AGG_i  	
	        READ(812,*) DIV_AGG_i	
	        READ(812,*) SEQ_AGG_i   
	        		        	        	        	        	        	        	        	        
	        READ(813,*) V_AGG_i
	        READ(813,*) PV_AGG_i
	        READ(813,*) rt_i 
	        READ(813,*) w_i	 
	        READ(813,*) ti_i	
	        READ(813,*) tdi	
	        
	        tgi	= tdi	  
	        
	        READ(8131,*) VC_AGG_i
	        READ(8131,*) C_AGG_i 		        
	        
	        r_i = rt_i/(1.0_8-ti_i) 	         	        	        	        	        	           	                                      

      do j=1,zgrid   
         do i=1,kgrid   
            READ(814,*)  Vi(i,j)		
  	        READ(815,*)  PVi(i,j) 
	        READ(817,*)  divi(i,j)	  
	        READ(818,*)  seqi(i,j)	  
	        READ(819,*)  optin(i,j)	  
	        READ(8191,*) optMin(i,j)	  	        	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do     
      
      do j=1,zgrid   
         do i=1,kgrid-1   
	        READ(816,*)  disti( ((i-1)*zgrid) + j )	   	        	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do  
      
      do j=1,egrid   
         do i=1,sgrid     
            READ(830,*)   OptShare_I(i,j)
            READ(8301,*)  OptCons_I(i,j)
            READ(8302,*)  VC_I(i,j)	                 			        	  	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do   

       do j=1,egrid   
         do i=1,sgrid-1     
	        READ(831,*)  distCi ( ((i-1)*egrid) + j )		            
	     end do     	     	     	     	     	     	     	     	     	
      end do  
      
!xxxxxxxxxxxx LOAD S.S. 2 xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        
      OPEN (UNIT=712,  FILE="Agg1_F.txt", STATUS="OLD", ACTION="READ") 
      OPEN (UNIT=713,  FILE="Agg2_F.txt", STATUS="OLD", ACTION="READ")
      OPEN (UNIT=7131, FILE="Agg3_F.txt", STATUS="OLD", ACTION="READ")        
	        	        	        	          	        
      OPEN (UNIT=714,  FILE="Val_F.txt", STATUS="OLD", ACTION="READ") 
      OPEN (UNIT=715,  FILE="PVal_F.txt", STATUS="OLD", ACTION="READ")    
      OPEN (UNIT=716,  FILE="Dist_F.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=717,  FILE="Div_F.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=718,  FILE="Seq_F.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=719,  FILE="OptK_F.txt", STATUS="OLD", ACTION="READ") 
      OPEN (UNIT=7191, FILE="OptMULT_F.txt", STATUS="OLD", ACTION="READ") 
      
      OPEN (UNIT=730,  FILE="OptShare_F.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=7301, FILE="OptCons_F.txt", STATUS="OLD", ACTION="READ")  
      OPEN (UNIT=7302, FILE="VC_F.txt", STATUS="OLD", ACTION="READ")              
      OPEN (UNIT=731,  FILE="DistC_F.txt", STATUS="OLD", ACTION="READ")   
                      
   	        READ(712,*) K_AGG_f  	
 	        READ(712,*) L_AGG_f	
	        READ(712,*) Y_AGG_f
	        READ(712,*) I_AGG_f  	
	        READ(712,*) C_AGG_f   	
	        READ(712,*) AC_AGG_f
	        READ(712,*) G_AGG_f  	
	        READ(712,*) DIV_AGG_f	
	        READ(712,*) SEQ_AGG_f   
	        		        	        	        	        	        	        	        	        
	        READ(713,*) V_AGG_f
	        READ(713,*) PV_AGG_f
	        READ(713,*) rt_f 
	        READ(713,*) w_f	 
	        READ(713,*) ti_f	
	        READ(713,*) tdf		
	        
	        tgf	= tdf	        
	        
	        READ(7131,*) VC_AGG_f
	        READ(7131,*) C_AGG_f 			        
	        
	        r_f = rt_f/(1.0_8-ti_f) 	         	        	        	        	        	           	                                      

      do j=1,zgrid   
         do i=1,kgrid   
            READ(714,*)  Vf(i,j)		
  	        READ(715,*)  PVf(i,j) 
	        READ(717,*)  divf(i,j)	  
	        READ(718,*)  seqf(i,j)	  
	        READ(719,*)  optf(i,j)	  
	        READ(7191,*) optMf(i,j)	  	        	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do     
      
      do j=1,zgrid   
         do i=1,kgrid-1   
	        READ(716,*)  distf( ((i-1)*zgrid) + j )	   	        	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do  
      
      do j=1,egrid   
         do i=1,sgrid     
            READ(730,*)   OptShare_F(i,j)
            READ(7301,*)  OptCons_F(i,j)
            READ(7302,*)  VC_F(i,j)	             			        	  	        	        	              			        
	     end do     	     	     	     	     	     	     	     	     	
      end do   

       do j=1,egrid   
         do i=1,sgrid-1     
	        READ(731,*)  distCf ( ((i-1)*egrid) + j )		            
	     end do     	     	     	     	     	     	     	     	     	
      end do       

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxx   INITIAL ALLOCATIONS   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

      	    optK(:,:,Ts)     = optf
	        optMULT(:,:,Ts)  = optMf
	        optD(:,:,Ts)     = divf
            optS(:,:,Ts)     = seqf
            optShare(:,:,Ts) = OptShare_F
            optCons(:,:,Ts)  = OptCons_F       
          	VC(:,:,Ts)       = VC_F                

            stepk1   = ( (rt_f-(rt_i + 0.00_8))/(Ts-2) )     
            stepk2   = ( (w_f-w_i)/(Ts-1) )    
	    
	        do i=1,Ts-1
			    rp(i)    = ( rt_i + 0.00_8 ) + ( stepk1*(i-1) )			
            end do 
            do i=1,Ts
		        wp(i)    =   w_i + ( stepk2*(i-1) )			
            end do 

                !    OPEN (UNIT=444,  FILE="read-rp.txt", STATUS="OLD", ACTION="READ")  
                !    OPEN (UNIT=445,  FILE="read-wp.txt", STATUS="OLD", ACTION="READ") 

                !    do i=1,Ts-1       
	            !       READ(444,*)  rp(i)
	            !    end do         
                !    do i=1,Ts       
	            !       READ(445,*)  wp(i)
	            !    end do   
       
            rp2 = rp
            wp2 = wp  

            do i=1,Ts
			    td(i)  =  tdf
			    tg(i)  =  tgf
			    tc(i)  =  tcf						 
            end do 
            
                  OPEN (UNIT=11211, FILE="X-rp-int.txt", STATUS="NEW") 
                  OPEN (UNIT=11311, FILE="X-wp-int.txt", STATUS="NEW")             
            
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

        tol_main  = 100.0_8
        iter_main = 1

DO WHILE (tol_main.ge.tol_iter.and.iter_main.lt.exitloop)   !!!!!!!! MAIN LOOP STARTS !!!!!!!!!

                  CLOSE(UNIT=11211, STATUS="DELETE") 
                  CLOSE(UNIT=11311, STATUS="DELETE")     

            rp = (rp*relaxR) + (rp2*(1.0_8-relaxR))
            wp = (wp*relaxW) + (wp2*(1.0_8-relaxW))            

            print *, "------------------------------------------------------"
            print *, "Iteration = ", iter_main              

	        do i=1,Ts-1
		        rf(i)    = (  1.0_8 + (rp(i)*(1.0_8/(1.0_8-tg(i+1))))  )
            end do 

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxx  FIRM PROBLEM - MAIN LOOP xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

           Call TIC

    DO tt=1,Ts-1
            
        do j=1,zgrid
        do i=1,kgrid    
      	    pi(i,j)  = z(j)*(1-nu)*(k(i)**alf)*((z(j)*nu*(k(i)**alf)/wp(Ts-tt))**(nu/(1.0_8-nu)))             	
	    end do
	    end do  
	    
        do j=1,zgrid   
           do i=1,kgrid     
	                    kL = k(1)
	                    kH = k(kgrid)	        
	                    errorK = 1.0_8
	         
	                    A_LOOP : DO 
	                        if (abs(errorK).lt.tolerrorK2) exit A_LOOP	       
	                            kc  = (kL+kH)/2.0_8
	                            pay = ( (1.0_8-tc(Ts-tt))*pi(i,j) ) + ( tc(Ts-tt)*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (kc) - ((1.0_8-(tc(Ts-tt)*phi))*(psi/2.0_8)*(((kc/k(i))-1.0_8)**2)*k(i))   ! NEW NEW NEW NEW NEW NEW NEW NEW
				            if (pay.gt.0) then                                                                                             
				                kL = kc
				            else
				                kH = kc
				            end if  
				            errorK = abs(kL-kH)    	              
	                    END DO A_LOOP
	        
                        xx=minloc( abs(k-(kc*ones)) )			       
					    x1=xx(1)
					    if(k(x1).gt.kc.or.x1.eq.kgrid) x1=x1-1 
					    weight= ( kc-k(x1) ) / ( k(x1+1)-k(x1) )					 
					    do op=1,zgrid
					        lllp(op)  = (z(op)*nu*(kc**alf)/wp(Ts-tt+1))**(1.0_8/(1.0_8-nu))
					        prop(op)  =  z(op)*alf*(kc**(alf-1.0_8))*(lllp(op)**nu)
					        piip(op)  =  z(op)*(1-nu)*(kc**alf)*((z(op)*nu*(kc**alf)/wp(Ts-tt+1))**(nu/(1.0_8-nu))) 
					        kkkp(op)  = ( weight*optK(x1+1,op,Ts-tt+1)    ) + ( (1.0_8-weight)*optK(x1,op,Ts-tt+1)    )
					        mult(op)  = ( weight*optMULT(x1+1,op,Ts-tt+1) ) + ( (1.0_8-weight)*optMULT(x1,op,Ts-tt+1) )
					        xxxp(op)  = (kkkp(op))-((1.0_8-delta)*kc)    ! NEW NEW NEW NEW NEW NEW NEW NEW
					        payp(op)  = ( (1.0_8-tc(Ts-tt+1))*piip(op) ) + ( tc(Ts-tt+1)*delta*kc ) + ( (1.0_8-delta)*kc ) - (kkkp(op)) - ((1.0_8-(tc(Ts-tt+1)*phi))*(psi/2.0_8)*(((kkkp(op)/kc)-1.0_8)**2)*kc)	  ! NEW NEW NEW NEW NEW NEW NEW NEW			        
					                                                                                                                                
				            MBterm(op) = ((1-td(Ts-tt+1))/(1-tg(Ts-tt+1))) + mult(op)
				         					 
					        MB2(op)   = (1.0_8/rf(Ts-tt)) * MBterm(op) * (   ((1.0_8-tc(Ts-tt+1))*prop(op)) + (tc(Ts-tt+1)*delta) - ((1.0_8-(tc(Ts-tt+1)*phi))*(psi/2.0_8)*(((kkkp(op)/kc)-1.0_8)**2)) + ((1.0_8-(tc(Ts-tt+1)*phi))*psi*((kkkp(op)/kc)-1.0_8)*(kkkp(op)/kc)) + (1.0_8-delta)  )  										 
				        end do                                                                                                    
				            MB = sum(tz(j,:)*MB2)	
				            MB = MB / ( (1.0_8) + ((1.0_8-(tc(Ts-tt)*phi))*psi*((kc/k(i))-1.0_8)) )   ! NEW NEW NEW NEW NEW NEW NEW NEW
				            LamD = MB - ( (1.0_8-td(Ts-tt))/(1.0_8-tg(Ts-tt)) )
				            LamS = 1.0_8 - ( (1.0_8-td(Ts-tt))/(1.0_8-tg(Ts-tt)) ) - LamD
				            
				            
			  IF (LamD.ge.0.and.LamS.ge.0) THEN
			       kkk   = kc
			       check = abs(kc-k(kgrid))
			       if (check.lt.tolerrorK2) then
			       multD = 0.0_8
			       else			       
			       multD = LamD
			       end if
			       		    
			  ELSE
			        if (LamD.lt.0) then
			                multD = 0.0_8
			                kL = k(1)
	                        kH = kc
	                        errorK = 1.0_8
	                
	                        B_LOOP : DO 
	                            if (abs(errorK).lt.tolerrorK) exit	B_LOOP       
	                                kkk  = (kL+kH)/2.0_8	                          				          	  
				          	        xx=minloc( abs(k-(kkk*ones)) )			       
					                x1=xx(1)
					                if(k(x1).gt.kkk.or.x1.eq.kgrid) x1=x1-1 
					                weight= ( kkk-k(x1) ) / ( k(x1+1)-k(x1) )					 
					                do op=1,zgrid
					                    lllp(op)  = (z(op)*nu*(kkk**alf)/wp(Ts-tt+1))**(1.0_8/(1.0_8-nu))
					                    prop(op)  =  z(op)*alf*(kkk**(alf-1.0_8))*(lllp(op)**nu)
					                    piip(op)  =  z(op)*(1-nu)*(kkk**alf)*((z(op)*nu*(kkk**alf)/wp(Ts-tt+1))**(nu/(1.0_8-nu))) 
					                    kkkp(op)  = ( weight*optK(x1+1,op,Ts-tt+1)    ) + ( (1.0_8-weight)*optK(x1,op,Ts-tt+1)    )
					                    mult(op)  = ( weight*optMULT(x1+1,op,Ts-tt+1) ) + ( (1.0_8-weight)*optMULT(x1,op,Ts-tt+1) )
					                    xxxp(op)  = (kkkp(op))-((1.0_8-delta)*kkk)    ! NEW NEW NEW NEW NEW NEW NEW NEW
					                    payp(op)  = ( (1.0_8-tc(Ts-tt+1))*piip(op) ) + ( tc(Ts-tt+1)*delta*kkk ) + ( (1.0_8-delta)*kkk ) - (kkkp(op)) - ((1.0_8-(tc(Ts-tt+1)*phi))*(psi/2.0_8)*(((kkkp(op)/kkk)-1.0_8)**2)*kkk)	   ! NEW NEW NEW NEW NEW NEW NEW NEW				        
					                                                                                                                                             
				                        MBterm(op) = ((1-td(Ts-tt+1))/(1-tg(Ts-tt+1))) + mult(op)
				                     					 
					                    MB2(op)   = (1.0_8/rf(Ts-tt)) * MBterm(op) * (   ((1.0_8-tc(Ts-tt+1))*prop(op)) + (tc(Ts-tt+1)*delta) - ((1.0_8-(tc(Ts-tt+1)*phi))*(psi/2.0_8)*(((kkkp(op)/kkk)-1.0_8)**2)) + ((1.0_8-(tc(Ts-tt+1)*phi))*psi*((kkkp(op)/kkk)-1.0_8)*(kkkp(op)/kkk)) + (1.0_8-delta)   )  										 
				                    end do                                                                 
				                        MB = sum(tz(j,:)*MB2)
				                        MC = ((1-td(Ts-tt))/(1-tg(Ts-tt))) * ( (1.0_8) + ((1.0_8-(tc(Ts-tt)*phi))*psi*((kkk/k(i))-1.0_8)) ) 	  ! NEW NEW NEW NEW NEW NEW NEW NEW
				                                                          
				                        if (MC.lt.MB) then
				                            kL = kkk
				                        else
				                            kH = kkk
				                        end if  				  
				                            errorK = abs(kL-kH)   				          	     
				                        				          	              
	                        END DO B_LOOP
	                         	                    
	                else
			                check = abs(kc-k(kgrid))
	                        if (check.lt.tolerrorK2) then
	                            multD = 0.0_8
	                        else	
	                            multD = 1.0_8 - ((1-td(Ts-tt))/(1-tg(Ts-tt)))
	                        end if

			                kL = kc
	                        kH = k(kgrid)
	                        errorK = 1.0_8
	                
	                        C_LOOP : DO 
	                            if (abs(errorK).lt.tolerrorK) exit	C_LOOP       
	                                kkk  = (kL+kH)/2.0_8	                          				          	  
				          	        xx=minloc( abs(k-(kkk*ones)) )			       
					                x1=xx(1)
					                if(k(x1).gt.kkk.or.x1.eq.kgrid) x1=x1-1 
					                weight= ( kkk-k(x1) ) / ( k(x1+1)-k(x1) )					 
					                do op=1,zgrid
					                    lllp(op)  = (z(op)*nu*(kkk**alf)/wp(Ts-tt+1))**(1.0_8/(1.0_8-nu))
					                    prop(op)  =  z(op)*alf*(kkk**(alf-1.0_8))*(lllp(op)**nu)
					                    piip(op)  =  z(op)*(1-nu)*(kkk**alf)*((z(op)*nu*(kkk**alf)/wp(Ts-tt+1))**(nu/(1.0_8-nu))) 
					                    kkkp(op)  = ( weight*optK(x1+1,op,Ts-tt+1)    ) + ( (1.0_8-weight)*optK(x1,op,Ts-tt+1) )
					                    mult(op)  = ( weight*optMULT(x1+1,op,Ts-tt+1) ) + ( (1.0_8-weight)*optMULT(x1,op,Ts-tt+1) )
					                    xxxp(op)  = (kkkp(op))-((1.0_8-delta)*kkk)    ! NEW NEW NEW NEW NEW NEW NEW NEW
					                    payp(op)  = ( (1.0_8-tc(Ts-tt+1))*piip(op) ) + ( tc(Ts-tt+1)*delta*kkk ) + ( (1.0_8-delta)*kkk ) - (kkkp(op)) - ((1.0_8-(tc(Ts-tt+1)*phi))*(psi/2.0_8)*(((kkkp(op)/kkk)-1.0_8)**2)*kkk) 	 ! NEW NEW NEW NEW NEW NEW NEW NEW				        
					                                                                                                                                              
					                    MBterm(op) = ((1-td(Ts-tt+1))/(1-tg(Ts-tt+1))) + mult(op)
					                      					 
					                    MB2(op)   = (1.0_8/rf(Ts-tt)) * MBterm(op) * (   ((1.0_8-tc(Ts-tt+1))*prop(op)) + (tc(Ts-tt+1)*delta) - ((1.0_8-(tc(Ts-tt+1)*phi))*(psi/2.0_8)*(((kkkp(op)/kkk)-1.0_8)**2)) + ((1.0_8-(tc(Ts-tt+1)*phi))*psi*((kkkp(op)/kkk)-1.0_8)*(kkkp(op)/kkk)) + (1.0_8-delta)  )  										 
				                    end do                                                                                                   
				                            MB = sum(tz(j,:)*MB2)
				                            MC = ( (1.0_8) + ((1.0_8-(tc(Ts-tt)*phi))*psi*((kkk/k(i))-1.0_8)) ) ! NEW NEW NEW NEW NEW NEW NEW NEW
				                                 
				                            if (MC.lt.MB) then
				                                kL = kkk
				                            else
				                                kH = kkk
				                            end if  				  
				                            errorK = abs(kL-kH)   				          	     
				                        				          	              
	                        END DO C_LOOP 	                    	        	        
	        
	                end if
	                
	          END IF
	                
	          optK(i,j,Ts-tt)    = kkk
	          optMULT(i,j,Ts-tt) = multD
	          
	          pay = ( (1.0_8-tc(Ts-tt))*pi(i,j) ) + ( tc(Ts-tt)*delta*k(i) ) + ( (1.0_8-delta)*k(i) ) - (kkk) - ((1.0_8-(tc(Ts-tt)*phi))*(psi/2.0_8)*(((kkk/k(i))-1.0_8)**2)*k(i))   ! NEW NEW NEW NEW NEW NEW NEW NEW
	                                                                                                                      
	          optPi(i,j,Ts-tt)  = pi(i,j)
	          optPay(i,j,Ts-tt) = pay
	          optD(i,j,Ts-tt)   = max (  pay , 0.0_8 )	          
	          optS(i,j,Ts-tt)   = max ( -pay , 0.0_8 )	 
	        	        	        	  	        	        	              			        
	       end do     	     	     	     	     	     	     	     	     	
        end do 	    

    END DO
     
        PRINT *, 'Firm Problem Completed.          Time :', toc() 
         
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxx  MACRO AGGREGATES & DISTRIBUTION xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

      Call TIC 

           stdisT       = 0.0_8        	    
      	   stdisT(:,1)  = disti 

           K_AGG_T       = 0.0_8  
           KP_AGG_T      = 0.0_8       	   
      	   L_AGG_T       = 0.0_8                  
           Y_AGG_T       = 0.0_8  
           G_AGG_T       = 0.0_8    
           I_AGG_T       = 0.0_8                            
      	   DIV_AGG_T     = 0.0_8  
           SEQ_AGG_T     = 0.0_8 
           AC_AGG_T      = 0.0_8              
           C_AGG_T       = 0.0_8     	   

      DO tt=1,Ts-1
        
            trans = 0.0_8 
            
            do j=1,zgrid
               do i=1,kgrid                                
                  optL(i,j,tt)   = (z(j)*nu*(k(i)**alf)/wp(tt))**(1.0_8/(1.0_8-nu))
                  optY(i,j,tt)   = ( z(j) * (k(i)**alf) * (optL(i,j,tt)**nu)  ) 
                  optAC(i,j,tt)  = (psi/2.0_8)*(((optK(i,j,tt)/k(i))-1.0_8)**2)*k(i)              
	              optG(i,j,tt)   = ( td(tt)*optD(i,j,tt) ) - ( tg(tt)*optS(i,j,tt) ) + ( tc(tt)*(optPi(i,j,tt)-(delta*k(i))-(phi*optAC(i,j,tt))) )
	              optI(i,j,tt)   = (optK(i,j,tt)) - ((1.0_8-delta)*k(i))  
               end do
            end do
                                         
            do i=1,kgrid-1
               K_AGG_T(tt)   = K_AGG_T(tt)    + sum(  ( (k(i)+k(i+1))/2.0_8 )                   * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )
               KP_AGG_T(tt)  = KP_AGG_T(tt)   + sum(  ( (optK(i,:,tt)+optK(i+1,:,tt))/2.0_8 )   * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )
               L_AGG_T(tt)   = L_AGG_T(tt)    + sum(  ( (optL(i,:,tt)+optL(i+1,:,tt))/2.0_8 )   * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )
               Y_AGG_T(tt)   = Y_AGG_T(tt)    + sum(  ( (optY(i,:,tt)+optY(i+1,:,tt))/2.0_8 )   * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )  
               G_AGG_T(tt)   = G_AGG_T(tt)    + sum(  ( (optG(i,:,tt)+optG(i+1,:,tt))/2.0_8 )   * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  ) 
               I_AGG_T(tt)   = I_AGG_T(tt)    + sum(  ( (optI(i,:,tt)+optI(i+1,:,tt))/2.0_8 )   * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )                                 
               DIV_AGG_T(tt) = DIV_AGG_T(tt)  + sum(  ( (optD(i,:,tt)+optD(i+1,:,tt))/2.0_8 )   * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )   
               SEQ_AGG_T(tt) = SEQ_AGG_T(tt)  + sum(  ( (optS(i,:,tt)+optS(i+1,:,tt))/2.0_8 )   * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )   
               AC_AGG_T(tt)  = AC_AGG_T(tt)   + sum(  ( (optAC(i,:,tt)+optAC(i+1,:,tt))/2.0_8 ) * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )                           
                    do j=1,zgrid	        
                        xx=minloc(abs(k-(optK(i,j,tt)*ones)))			       
                        x1=xx(1)
                        if (k(x1).gt.optK(i,j,tt).or.x1.eq.kgrid) x1=x1-1		
                        xx=minloc(abs(k-(optK(i+1,j,tt)*ones)))		                
                        x2=xx(1)                
                        if (k(x2).gt.optK(i+1,j,tt).or.x2.eq.kgrid) x2=x2-1                
                        if (x2.eq.x1) then
                               trans( ((i-1)*zgrid)+j , (((x1-1)*zgrid)+1):(x1*zgrid) ) = tz(j,:)
				        else
                            do oo=x1,x2
                               trans( (i-1)*zgrid+j , (oo-1)*zgrid+1:oo*zgrid ) = tz(j,:) * (min(k(oo+1),optK(i+1,j,tt))-max(k(oo),optK(i,j,tt)))/(optK(i+1,j,tt)-optK(i,j,tt))
                            end do
                        end if				
	                end do                                                                                                 
            end do
            
            stdisT(:,tt+1)=MATMUL(stdisT(:,tt),trans)   
                              
            C_AGG_T(tt) = Y_AGG_T(tt) - I_AGG_T(tt) - AC_AGG_T(tt) - gov         
                    
      END DO
      
           L_AGG_T(Ts)   =  L_AGG_f  
           K_AGG_T(Ts)   =  K_AGG_f      
           KP_AGG_T(Ts)  =  K_AGG_f                 
           I_AGG_T(Ts)   =  I_AGG_f
           Y_AGG_T(Ts)   =  Y_AGG_f                           
           AC_AGG_T(Ts)  =  AC_AGG_f 
           C_AGG_T(Ts)   =  C_AGG_f   
           DIV_AGG_T(Ts) =  DIV_AGG_f  
           SEQ_AGG_T(Ts) =  SEQ_AGG_f   
           G_AGG_T(Ts)   =  G_AGG_f    
           ti(Ts)        =  ti_f  
           
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxx  VALUE FUNCTIONS  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

	  V(:,:,Ts)     =  Vf
	  PV(:,:,Ts)    =  PVf	  

      DO tt=1,Ts-1   
    
            do j=1,zgrid
            do i=1,kgrid
                kc     = optK(i,j,Ts-tt)
                ddd    = optD(i,j,Ts-tt)
                ssseq  = optS(i,j,Ts-tt) 
                xx=minloc( abs(k-(kc*ones)) )			       
			    x1=xx(1)
			    if(k(x1).gt.kc.or.x1.eq.kgrid) x1=x1-1 
			    weight= ( kc-k(x1) ) / ( k(x1+1)-k(x1) )	
        
                TV = 0.0_8
                do nn=1,zgrid
                    TV = TV + (    tz(j,nn) * ((weight*V(x1+1,nn,Ts-tt+1))+((1.0_8-weight)*V(x1,nn,Ts-tt+1)))    )                               
                end do
            
                V(i,j,Ts-tt)  = ( ((1.0_8-td(Ts-tt))/(1.0_8-tg(Ts-tt)))*ddd ) - ssseq + ( (1.0_8/rf(Ts-tt))*TV )
                PV(i,j,Ts-tt) = V(i,j,Ts-tt) + optS(i,j,Ts-tt) - ( ((1.0_8-td(Ts-tt))/(1.0_8-tg(Ts-tt)))*optD(i,j,Ts-tt) )                                 
            end do    
            end do                  
    
      END DO

      V_AGG_T   = 0.0_8
      PV_AGG_T  = 0.0_8 
      
      DO tt=1,Ts-1  
            do i=1,kgrid-1
                V_AGG_T(tt)   = V_AGG_T(tt)   + sum(  ( (V(i,:,tt)+V(i+1,:,tt))/2.0_8   ) * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )
                PV_AGG_T(tt)  = PV_AGG_T(tt)  + sum(  ( (PV(i,:,tt)+PV(i+1,:,tt))/2.0_8 ) * ( stdisT(((i-1)*zgrid)+1:(i*zgrid),tt) )  )         
            end do
      END DO

      V_AGG_T(Ts)   = V_AGG_f
      PV_AGG_T(Ts)  = PV_AGG_f 
      
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxx  CALCULATE ti and cap. gains  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      
      
            CAP_GAIN(1)  = tg(1)  *  ( PV_AGG_T(1) - (PV_AGG_i)  )    ! NEW NEW NEW NEW NEW NEW NEW NEW
     
            do tt=2,Ts
                CAP_GAIN(tt) = tg(tt) *  ( PV_AGG_T(tt) - (PV_AGG_T(tt-1))  )    ! NEW NEW NEW NEW NEW NEW NEW NEW
            end do
     
            do tt=1,Ts-1
                if (check_ti.gt.0) then
                    check = 1               
                else
                    ti(tt) = ( gov - G_AGG_T(tt) - CAP_GAIN(tt) ) / ( wp(tt)*L_AGG_T(tt) )
                end if           
                    G_AGG_T(tt) = gov    
            end do      
      
 !xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
                            
      PRINT *, 'Firm Distribution Completed.     Time :', toc() 
                                
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxx   CONSUMER PROBLEM - MAIN LOOP   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
                
            Call TIC                  
      
      DO tt=1,Ts-1
      
            RR(Ts-tt) = ( ( (((1.0_8-td(Ts-tt+1))*DIV_AGG_T(Ts-tt+1))-((1.0_8-tg(Ts-tt+1))*SEQ_AGG_T(Ts-tt+1))+PV_AGG_T(Ts-tt+1)) ) - ( tg(Ts-tt+1)*(PV_AGG_T(Ts-tt+1)-(PV_AGG_T(Ts-tt))) )  ) / (PV_AGG_T(Ts-tt))  ! NEW NEW NEW NEW NEW NEW NEW NEW
     
            do j=1,egrid
            do i=1,sgrid
                  if (tt.eq.Ts-1) then
                     wealth(i,j) = ( (((1.0_8-td(Ts-tt))*DIV_AGG_T(Ts-tt))-((1.0_8-tg(Ts-tt))*SEQ_AGG_T(Ts-tt))+PV_AGG_T(Ts-tt))*s(i) ) + ( wp(Ts-tt)*(1.0_8-ti(Ts-tt))*e(j) ) - (tg(Ts-tt)*(PV_AGG_T(Ts-tt)-(PV_AGG_i))*s(i))  ! NEW NEW NEW NEW NEW NEW NEW NEW
                  else
                     wealth(i,j) = ( (((1.0_8-td(Ts-tt))*DIV_AGG_T(Ts-tt))-((1.0_8-tg(Ts-tt))*SEQ_AGG_T(Ts-tt))+PV_AGG_T(Ts-tt))*s(i) ) + ( wp(Ts-tt)*(1.0_8-ti(Ts-tt))*e(j) ) - (tg(Ts-tt)*(PV_AGG_T(Ts-tt)-(PV_AGG_T(Ts-tt-1)))*s(i))  ! NEW NEW NEW NEW NEW NEW NEW NEW
                  end if
                     smin = s(1)
                     smax = min ( (wealth(i,j)-0.000001_8)/PV_AGG_T(Ts-tt) , s(sgrid) )
                     errorS = 1.0_8
        
                  H_LOOP : DO 
	                  if (abs(errorS).lt.tolS) exit H_LOOP	       
                      sss  = (smin+smax)/2.0_8
                      ccc  = wealth(i,j) - (PV_AGG_T(Ts-tt)*sss)
                      mu0  = (ccc**(-sigma))  
             
                      xx=minloc( abs(s-(sss*onesC)) )			       
			          x1=xx(1)
			          if(s(x1).gt.sss.or.x1.eq.sgrid) x1=x1-1 
			          weight= ( sss-s(x1) ) / ( s(x1+1)-s(x1) )
			 
			          do oo=1,egrid
			             wwwp(oo) = ( (((1.0_8-td(Ts-tt+1))*DIV_AGG_T(Ts-tt+1))-((1.0_8-tg(Ts-tt+1))*SEQ_AGG_T(Ts-tt+1))+PV_AGG_T(Ts-tt+1))*sss ) + ( wp(Ts-tt+1)*(1.0_8-ti(Ts-tt+1))*e(oo) ) - (tg(Ts-tt+1)*(PV_AGG_T(Ts-tt+1)-(PV_AGG_T(Ts-tt)))*sss)	  ! NEW NEW NEW NEW NEW NEW NEW NEW		                        
			             sssp(oo) = ((weight*optShare(x1+1,oo,Ts-tt+1))+((1.0_8-weight)*optShare(x1,oo,Ts-tt+1)))
			             sssp(oo) = min ( (wwwp(oo)-0.000001_8)/PV_AGG_T(Ts-tt+1) , sssp(oo) )
			             cccp(oo) = wwwp(oo) - ( PV_AGG_T(Ts-tt+1)*sssp(oo) )
			             mu1p(oo) = (cccp(oo)**(-sigma))			    
			          end do
			 
				       !   mu1 = beta*(1.0_8+rp(Ts-tt))*sum(te(j,:)*mu1p)				    
				           mu1 = beta*RR(Ts-tt)*sum(te(j,:)*mu1p)	
				
				         if (mu0.lt.mu1) then
				            smin = sss
				         else
				            smax = sss
				         end if  				  
				            errorS = abs(smin-smax)			 		               	              
	              END DO H_LOOP
        
                  optShare(i,j,Ts-tt) = sss
                  optCons(i,j,Ts-tt)  = ccc
                  
               !  VC(i,j,Ts-tt)       = ( (optCons(i,j,Ts-tt)**(1.0_8-sigma))/(1.0_8-sigma) ) + ( beta * sum(te(j,:)*((weight*VC(x1+1,:,Ts-tt+1))+((1.0_8-weight)*VC(x1,:,Ts-tt+1)))) )
                  
                  VC(i,j,Ts-tt)       = ( log(optCons(i,j,Ts-tt))  )                          + ( beta * sum(te(j,:)*((weight*VC(x1+1,:,Ts-tt+1))+((1.0_8-weight)*VC(x1,:,Ts-tt+1)))) )
     
            end do
            end do      

      END DO
      
      PRINT *, 'Consumer Problem Completed.      Time :', toc()          
                    
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxx   MACRO AGGREGATES & DISTRIBUTION   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

      Call TIC 

           stdisT_C       = 0.0_8        	    
      	   stdisT_C(:,1)  = distCi  
           
      DO tt=1,Ts-1        
            transC = 0.0_8                                          
                 do i=1,sgrid-1
                    do j=1,egrid	        
                        xx=minloc(abs(s-(optShare(i,j,tt)*onesC)))			       
                        x1=xx(1)
                        if (s(x1).gt.optShare(i,j,tt).or.x1.eq.sgrid) x1=x1-1		
                        xx=minloc(abs(s-(optShare(i+1,j,tt)*onesC)))		                
                        x2=xx(1)                
                        if (s(x2).gt.optShare(i+1,j,tt).or.x2.eq.sgrid) x2=x2-1                
                        if (x2.eq.x1) then
                               transC( ((i-1)*egrid)+j , (((x1-1)*egrid)+1):(x1*egrid) ) = te(j,:)
				        else
                            do oo=x1,x2
                               transC( ((i-1)*egrid)+j , (oo-1)*egrid+1:oo*egrid ) = te(j,:) * (min(s(oo+1),optShare(i+1,j,tt))-max(s(oo),optShare(i,j,tt)))/(optShare(i+1,j,tt)-optShare(i,j,tt))
                            end do
                        end if				
	                end do                                                                                                 
                 end do            
            stdisT_C(:,tt+1)=MATMUL(stdisT_C(:,tt),transC)                                                            
      END DO  
      
      S_AGG_T       = 0.0_8
      CONS_AGG_T    = 0.0_8 
      VC_AGG_T      = 0.0_8   
      
      DO tt=1,Ts                                                 
            do i=1,sgrid-1
                   S_AGG_T(tt)     =  S_AGG_T(tt)       + sum(  ( (s(i)+s(i+1))/2.0_8 ) * ( stdisT_C(((i-1)*egrid)+1:(i*egrid),tt) )  )
                   CONS_AGG_T(tt)  =  CONS_AGG_T(tt)    + sum(  ( (optCons(i,:,tt)+optCons(i+1,:,tt))/2.0_8 ) * ( stdisT_C(((i-1)*egrid)+1:(i*egrid),tt) )  )                                                                                                      
                   VC_AGG_T(tt)    =  VC_AGG_T(tt)      + sum(  ( (VC(i,:,tt)+VC(i+1,:,tt))/2.0_8 ) * ( stdisT_C(((i-1)*egrid)+1:(i*egrid),tt) )  )
            end do                                                          
      END DO       
      
                   CONS_AGG_T(Ts) = C_AGG_f
                   VC_AGG_T(Ts)   = VC_AGG_f              
           
      PRINT *, 'Consumer Distribution Completed. Time :', toc()            
	   
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxx   CHECK R and W   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx                  

      DO tt=1,Ts-1            
           rp2(tt) = (  S_AGG_T(tt+1)**(alfRRR-1.0_8)  ) * rp(tt)
           wp2(tt) = wp(tt)*( (L_AGG_T(tt)/LLL)**(1.0_8-nu) )                                           
      END DO 
        
          tol_r = maxval(abs(rp-rp2))/rt_i       
          tol_w = maxval(abs(wp-wp2))/w_i
          tol_main = 100*max(tol_r,tol_w)
          
    print *, "------------------------------------------"    
    print *, "tolerance = ", tol_main
    print *, "tol_r     = ", 100*tol_r
    print *, "tol_w     = ", 100*tol_w          
                 
          iter_main = iter_main + 1
          
          
                  OPEN (UNIT=11211, FILE="X-rp-int.txt", STATUS="NEW") 
                  OPEN (UNIT=11311, FILE="X-wp-int.txt", STATUS="NEW")           
          
                    do tt=1,Ts-1   
                            WRITE(11211,*) rp(tt)
                            WRITE(11311,*) wp(tt)  	            	   	     	     	     	     	     	     	     	     	
                    end do    
         
  
END DO  !!!!!!!! MAIN LOOP ENDS !!!!!!!!!

pause

    print *, "=============================================="  
    print *, "=============================================="        
    print *, "tolerance = ", tol_main
    print *, "tol_r     = ", 100*tol_r
    print *, "tol_w     = ", 100*tol_w    
    print *, "=============================================="        
    print *, "=============================================="

pause	

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxx   WELFARE   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

            do j=1,egrid
            do i=1,sgrid
                VCp(i,j,Ts)      = ( (1.0_8/(1.0_8-beta))*log(C_AGG_f/C_AGG_i) )  +  VC_I(i,j) 
            end do
            end do   

      DO tt=1,Ts-1     
            do j=1,egrid
            do i=1,sgrid
                    sss = OptShare_I(i,j)
                    xx=minloc( abs(s-(sss*onesC)) )			       
			        x1=xx(1)
			        if(s(x1).gt.sss.or.x1.eq.sgrid) x1=x1-1 
			        weight= ( sss-s(x1) ) / ( s(x1+1)-s(x1) )
                VCp(i,j,Ts-tt)   =   log( OptCons_I(i,j) * CONS_AGG_T(Ts-tt) / C_AGG_i ) + ( beta * sum(te(j,:)*((weight*VCp(x1+1,:,Ts-tt+1))+((1.0_8-weight)*VCp(x1,:,Ts-tt+1)))) )
            end do
            end do      
      END DO
     
      VC_AGG_TP = 0.0_8
      
      DO tt=1,Ts                                                 
            do i=1,sgrid-1
                   VC_AGG_TP(tt)    =  VC_AGG_TP(tt)      + sum(  ( (VCp(i,:,tt)+VCp(i+1,:,tt))/2.0_8 ) * ( stdisT_C(((i-1)*egrid)+1:(i*egrid),1) )  )
            end do                                                           
      END DO 

            CE_TOTAL         =    ( exp((1.0_8-beta)*(VC_AGG_f-VC_AGG_i)) ) - 1.0_8                                     
            CE_AGGREGATE     =    ( exp((1.0_8-beta)*(VC_AGG_TP(Ts)-VC_AGG_i)) ) - 1.0_8        
            CE_DISTRIBUTION  =  ( ( 1.0_8 + CE_TOTAL ) / ( 1.0_8 + CE_AGGREGATE ) ) - 1.0_8

            DO tt=1,Ts
               CE_TOTAL_T(Ts+1-tt)         =   ( exp((1.0_8-beta)*(VC_AGG_T(Ts+1-tt)-VC_AGG_i)) ) - 1.0_8                             
               CE_AGGREGATE_T(Ts+1-tt)     =   ( exp((1.0_8-beta)*(VC_AGG_TP(Ts+1-tt)-VC_AGG_i)) ) - 1.0_8                    
               CE_DISTRIBUTION_T(Ts+1-tt)  =   ( ( 1.0_8 + CE_TOTAL_T(Ts+1-tt) ) / ( 1.0_8 + CE_AGGREGATE_T(Ts+1-tt) ) ) - 1.0_8
            END DO
            
            
!-------------------------------------------------------------------------------------------------------------            

            print *, "---------------------------------------------------"  
            print *, "------------ Welfare : SS -------------------------"  
            print *, "---------------------------------------------------"         
            print *, "CE Total SS          : ", CE_TOTAL
            print *, "CE Aggregate SS      : ", CE_AGGREGATE
            print *, "CE Distribution SS   : ", CE_DISTRIBUTION
            print *, "---------------------------------------------------"  
            print *, "------------ Welfare : Initial --------------------"  
            print *, "---------------------------------------------------"         
            print *, "CE Total t=1         : ", CE_TOTAL_T(1)
            print *, "CE Aggregate t=1     : ", CE_AGGREGATE_T(1)
            print *, "CE Distribution t=1  : ", CE_DISTRIBUTION_T(1)
            print *, "---------------------------------------------------" 

pause

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
      
      OPEN (UNIT=11011, FILE="Tolerance.txt", STATUS="NEW") 
                  WRITE(11011,*) tol_main
                  WRITE(11011,*) 100*tol_r
                  WRITE(11011,*) 100*tol_w                                   

      OPEN (UNIT=110, FILE="X-r.txt", STATUS="NEW") 
      OPEN (UNIT=111, FILE="X-ti.txt", STATUS="NEW")     
      OPEN (UNIT=112, FILE="X-rp.txt", STATUS="NEW") 
      OPEN (UNIT=113, FILE="X-wp.txt", STATUS="NEW")        
  
            WRITE(110,*) r_i
            WRITE(110,*) r_i   
            WRITE(111,*) ti_i
            WRITE(111,*) ti_i                                  
            WRITE(112,*) rt_i
            WRITE(112,*) rt_i
            WRITE(113,*) w_i
            WRITE(113,*) w_i                        
      do tt=1,Ts-1   
            WRITE(110,*) rp(tt) / ( 1.0_8-ti(tt+1) )
            WRITE(111,*) ti(tt)
            WRITE(112,*) rp(tt)
            WRITE(113,*) wp(tt)  	            	   	     	     	     	     	     	     	     	     	
      end do       
            WRITE(110,*) r_f   
            WRITE(111,*) ti_f      
            WRITE(112,*) rt_f	
            WRITE(113,*) w_f	       
      
      OPEN (UNIT=114, FILE="X-K_AGG.txt", STATUS="NEW") 
      OPEN (UNIT=115, FILE="X-Y_AGG.txt", STATUS="NEW") 
      OPEN (UNIT=116, FILE="X-L_AGG.txt", STATUS="NEW") 
      OPEN (UNIT=117, FILE="X-C_AGG.txt", STATUS="NEW") 
      OPEN (UNIT=118, FILE="X-I_AGG.txt", STATUS="NEW")  
      OPEN (UNIT=119, FILE="X-G_AGG.txt", STATUS="NEW")     
      OPEN (UNIT=200, FILE="X-AC_AGG.txt", STATUS="NEW")                 
      OPEN (UNIT=211, FILE="X-DIV_AGG.txt", STATUS="NEW") 
      OPEN (UNIT=212, FILE="X-SEQ_AGG.txt", STATUS="NEW")     
      OPEN (UNIT=213, FILE="X-V_AGG.txt", STATUS="NEW") 
      OPEN (UNIT=214, FILE="X-PV_AGG.txt", STATUS="NEW")  
      OPEN (UNIT=215, FILE="X-SHARE_AGG.txt", STATUS="NEW")   
      OPEN (UNIT=216, FILE="X-CONS_AGG.txt", STATUS="NEW")                                                 
            
            WRITE(114,*) K_AGG_i
            WRITE(114,*) K_AGG_i
            WRITE(115,*) Y_AGG_i
            WRITE(115,*) Y_AGG_i
            WRITE(116,*) L_AGG_i
            WRITE(116,*) L_AGG_i
            WRITE(117,*) C_AGG_i
            WRITE(117,*) C_AGG_i
            WRITE(118,*) I_AGG_i
            WRITE(118,*) I_AGG_i    
            WRITE(119,*) G_AGG_i    
            WRITE(119,*) G_AGG_i 
            WRITE(200,*) AC_AGG_i    
            WRITE(200,*) AC_AGG_i                                                                                                            
      do tt=1,Ts   
            WRITE(114,*) K_AGG_T(tt)	
            WRITE(115,*) Y_AGG_T(tt)	
            WRITE(116,*) L_AGG_T(tt)	
            WRITE(117,*) C_AGG_T(tt)	
            WRITE(118,*) I_AGG_T(tt)	
            WRITE(119,*) G_AGG_T(tt)
            WRITE(200,*) AC_AGG_T(tt)            	                                                            	            	   	     	     	     	     	     	     	     	     	
      end do     
      
            WRITE(211,*) DIV_AGG_i
            WRITE(211,*) DIV_AGG_i
            WRITE(212,*) SEQ_AGG_i
            WRITE(212,*) SEQ_AGG_i
            WRITE(213,*) V_AGG_i
            WRITE(213,*) V_AGG_i
            WRITE(214,*) PV_AGG_i
            WRITE(214,*) PV_AGG_i 
            WRITE(215,*) 1.0_8
            WRITE(215,*) 1.0_8               
      do tt=1,Ts   
            WRITE(211,*) DIV_AGG_T(tt)	
            WRITE(212,*) SEQ_AGG_T(tt)	
            WRITE(213,*) V_AGG_T(tt)	
            WRITE(214,*) PV_AGG_T(tt)
            WRITE(215,*) S_AGG_T(tt) 
            WRITE(216,*) CONS_AGG_T(tt)                        		                                                	            	   	     	     	     	     	     	     	     	     	
      end do     	            	

      OPEN (UNIT=230, FILE="X-optK_1.txt", STATUS="NEW") 
      OPEN (UNIT=231, FILE="X-optD_1.txt", STATUS="NEW") 
      OPEN (UNIT=232, FILE="X-optS_1.txt", STATUS="NEW")

      do j=1,zgrid   
         do i=1,kgrid  
            WRITE(230,*) optK(i,j,1)
            WRITE(231,*) optD(i,j,1)	
            WRITE(232,*) optS(i,j,1) 	           		                                                	            	   	     	     	     	     	     	     	     	     	
          end do
      end do
      
      OPEN (UNIT=25, FILE="Z-VC_AGG_T.txt", STATUS="NEW") 
      OPEN (UNIT=26, FILE="Z-CONS_AGG_T.txt", STATUS="NEW") 
      OPEN (UNIT=35, FILE="Z-VC_SS.txt", STATUS="NEW")              
      OPEN (UNIT=36, FILE="Z-CONS_SS.txt", STATUS="NEW")            	            	

      do tt=1,Ts   
            WRITE(25,*) VC_AGG_T(tt)
            WRITE(26,*) CONS_AGG_T(tt)                       	                           	         	                                                            	            	   	     	     	     	     	     	     	     	     	
      end do        	            	
       	            	
            WRITE(35,*) VC_AGG_i
            WRITE(35,*) VC_AGG_f
            WRITE(36,*) C_AGG_i
            WRITE(36,*) C_AGG_f    

      OPEN (UNIT=13, FILE="Cons_t_1.txt", STATUS="NEW")  
      OPEN (UNIT=14, FILE="VC_t_1.txt", STATUS="NEW") 
      OPEN (UNIT=15, FILE="s_grid.txt", STATUS="NEW") 
       
      do j=1,egrid   
         do i=1,sgrid   
            WRITE(13,*) optCons(i,j,1) 
            WRITE(14,*) VC(i,j,1)                 
         end do
      end do  
      
         do i=1,sgrid   
            WRITE(15,*) s(i)                
         end do             
       
 !xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   

     OPEN (UNIT=610, FILE="STATS_CE.txt", STATUS="NEW")   

            WRITE(610,*)  "---------------------------------------------------"
            WRITE(610,*)  "CE Total SS          : ", CE_TOTAL
            WRITE(610,*)  "CE Aggregate SS      : ", CE_AGGREGATE
            WRITE(610,*)  "CE Distribution SS   : ", CE_DISTRIBUTION  
            WRITE(610,*)  "---------------------------------------------------"    
            WRITE(610,*)  "---------------------------------------------------"
            WRITE(610,*)  "CE Total t=1         : ", CE_TOTAL_T(1)
            WRITE(610,*)  "CE Aggregate t=1     : ", CE_AGGREGATE_T(1)
            WRITE(610,*)  "CE Distribution t=1  : ", CE_DISTRIBUTION_T(1)  
            WRITE(610,*)  "---------------------------------------------------"  

     OPEN (UNIT=611, FILE="STATS_CE_TOTAL.txt", STATUS="NEW")  
     OPEN (UNIT=612, FILE="STATS_CE_AGGREGATE.txt", STATUS="NEW")                                                                                       
     OPEN (UNIT=613, FILE="STATS_CE_DISTRIBUTION.txt", STATUS="NEW") 
     
     DO tt=1,TS
        WRITE(611,*)   CE_TOTAL_T(tt)
        WRITE(612,*)   CE_AGGREGATE_T(tt)
        WRITE(613,*)   CE_DISTRIBUTION_T(tt)
     END DO 
     
 !xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx   
    
     print *, "--------------------------"	  
     print *, "DONE !!!"	            	
     print *, "--------------------------"	     
     pause       
     print *, "--------------------------"	  
     print *, "DONE !!!"	            	
     print *, "--------------------------"	     
     pause  
     print *, "--------------------------"	  
     print *, "DONE !!!"	            	
     print *, "--------------------------"	     
     pause  


!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

END PROGRAM OLG

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx